/*------------------------------------------------------------------------------
 * $AstecId: cr-menus.c,v 1.2 2003/01/29 04:16:51 kosaka Exp $
 * $Source: /rcs/rcs2/customize/cr-menus.c,v $
 * $Date: 1996/11/09 16:38:17 $		$Revision: 2.11.65.1 $
 *------------------------------------------------------------------------------
 *		Copyright (c) 1991, Visual Edge Software Ltd.
 *
 * ALL  RIGHTS  RESERVED.  Permission  to  use,  copy,  modify,  and
 * distribute  this  software  and its documentation for any purpose
 * and  without  fee  is  hereby  granted,  provided  that the above
 * copyright  notice  appear  in  all  copies  and  that  both  that
 * copyright  notice and this permission notice appear in supporting
 * documentation,  and that  the name of Visual Edge Software not be
 * used  in advertising  or publicity  pertaining to distribution of
 * the software without specific, written prior permission. The year
 * included in the notice is the year of the creation of the work.
 *------------------------------------------------------------------------------
 * This file contains the specification of the UIM/X menus for creation
 * of new widget instances. The UxSpecify***Menu() functions are called
 * when the create menus are built.
 *----------------------------------------------------------------------------*/

/*
 * XRT products and UIM/X integration file
 *
 *  SCCSID -- @(#)cr-menus.c	1.2    97/02/10 KL Group Inc.
 */

/*--- include files ---*/

#include <stdio.h>
#include <Xm/Xm.h>
#include "uxproto.h"
#include "cat_macros.h"

#ifdef	XRT
#ifdef HASXRTGRAPH
extern void XrtGph_custmenu();
extern void XrtGph_tcustmenu();
#endif /* HASXRTGRAPH */

#ifdef HASXRT3D
extern void Xrt3d_custmenu();
extern void Xrt3d_tcustmenu();
#endif /* HASXRT3D */

#ifdef HASXRTTABLE
extern void XrtTbl_custmenu();
extern void XrtTbl_tcustmenu();
#endif /* HASXRTTABLE */

#ifdef HASXRTFIELD
extern void XrtFld_custmenu();
extern void XrtFld_tcustmenu();
#endif /* HASXRTFIELD */

#ifdef HASXRTGEAR
extern void XrtGear_custmenu();
extern void XrtGear_tcustmenu();
#endif /* HASXRTGEAR */

#ifdef HASXRTGAUGE
extern void XrtGauge_custmenu();
extern void XrtGauge_tcustmenu();
#endif /* HASXRTGAUGE */
#endif	/* XRT */

/*--- macro functions ---*/

/* The following macro is used to make the code more compact */
#define RING_CGETS_CRMENU(ms)	UxRingBuffer(CGETS_CRMENU(ms))

/*--- external functions ---*/

char	*UxRingBuffer UXPROTO((char *));
Widget	UxGetWidget UXPROTO(( swidget ));

swidget	UxAddToCreateMenu UXPROTO(( swidget, 
				    char *, 
				    char *, 
				    Boolean, 
				    void (*)(), 
				    Class_t, 
				    void (*)() ));

/*--- global variables ---*/

swidget	TopCustomMenuCasc, TopCustomMenuRowCol;
swidget	TopShellMenuCasc, TopShellMenuRowCol;
swidget	TopManagerMenuCasc, TopManagerMenuRowCol;
swidget	TopDialogMenuCasc, TopDialogMenuRowCol;
swidget	CustomMenuCasc, CustomMenuRowCol;
swidget	PrimitiveMenuCasc, PrimitiveMenuRowCol;
swidget	ManagerMenuCasc, ManagerMenuRowCol;
swidget	GadgetMenuCasc, GadgetMenuRowCol;

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyTopShellsMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Create menu for Shells
 *		in the Main Project Window.
 * LAST REV:	jun96 fix14287	nonVisualShell class.
 *----------------------------------------------------------------------------*/
void	UxSpecifyTopShellsMenu( casc_swgt, rowcol_swgt )
	swidget	rowcol_swgt;
	swidget	casc_swgt;
{
#ifndef DTSCRIPT
	extern	Class_t	UxC_applicationShell,
			UxC_dialogShell,
			UxC_nonVisualShell,
			UxC_overrideShell,
			UxC_topLevelShell,
			UxC_transientShell;

	TopShellMenuCasc = casc_swgt;
	TopShellMenuRowCol = rowcol_swgt;

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_SHL_APPLIC),
			RING_CGETS_CRMENU(CM_SHL_APPLIC_M),
			TRUE,
			(void (*)()) NULL,
			UxC_applicationShell,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_SHL_DIALOG),
			RING_CGETS_CRMENU(CM_SHL_DIALOG_M),
			TRUE,
			(void (*)()) NULL,
			UxC_dialogShell,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_SHL_OVERRD),
			RING_CGETS_CRMENU(CM_SHL_OVERRD_M),
			TRUE,
			(void (*)()) NULL,
			UxC_overrideShell,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_SHL_TOPLVL),
			RING_CGETS_CRMENU(CM_SHL_TOPLVL_M),
			TRUE,
			(void (*)()) NULL,
			UxC_topLevelShell,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_SHL_TRANSNT),
			RING_CGETS_CRMENU(CM_SHL_TRANSNT_M),
			TRUE,
			(void (*)()) NULL,
			UxC_transientShell,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_SHL_NONVISUAL),
			RING_CGETS_CRMENU(CM_SHL_NONVISUAL_M),
			TRUE,
			(void (*)()) NULL,
			UxC_nonVisualShell,
			(void (*)()) NULL );
#endif /* DTSCRIPT */
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyTopManagersMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Manager creation menu
 *		of the Main Project Window.
 * LAST REV:	jan 96 fix10723	Used RING_CGETS_CRMENU.
 *----------------------------------------------------------------------------*/
void	UxSpecifyTopManagersMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
	extern	Class_t	UxC_bulletinBoard,
			UxC_command,
			UxC_drawingArea,
			UxC_fileSelectionBox,
			UxC_form,
			UxC_frame,
			UxC_mainWindow,
			UxC_messageBox,
			UxC_panedWindow,
			UxC_rowColumn,
			UxC_scale,
			UxC_scrolledWindow,
			UxC_selectionBox;
		void	UxPopupMainWindowEditor();

	TopManagerMenuCasc = casc_swgt;
	TopManagerMenuRowCol = rowcol_swgt;

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_BULTNBRD),
			RING_CGETS_CRMENU(CM_MNG_BULTNBRD_M),
			TRUE,
			(void (*)()) NULL,
			UxC_bulletinBoard,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_COMM),
			RING_CGETS_CRMENU(CM_MNG_COMM_M),
			TRUE,
			(void (*)()) NULL,
			UxC_command,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_DRWGAREA),
			RING_CGETS_CRMENU(CM_MNG_DRWGAREA_M),
			TRUE,
			(void (*)()) NULL,
			UxC_drawingArea,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_FILESELBOX),
			RING_CGETS_CRMENU(CM_MNG_FILESELBOX_M),
			TRUE,
			(void (*)()) NULL,
			UxC_fileSelectionBox,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_FORM),
			RING_CGETS_CRMENU(CM_MNG_FORM_M),
			TRUE,
			(void (*)()) NULL,
			UxC_form,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_FRAME),
			RING_CGETS_CRMENU(CM_MNG_FRAME_M),
			TRUE,
			(void (*)()) NULL,
			UxC_frame,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_MAINWND),
			RING_CGETS_CRMENU(CM_MNG_MAINWND_M),
			TRUE,
			(void (*)()) NULL,
			UxC_mainWindow,
			UxPopupMainWindowEditor );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_MSGBOX),
			RING_CGETS_CRMENU(CM_MNG_MSGBOX_M),
			TRUE,
			(void (*)()) NULL,
			UxC_messageBox,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_PANEDWND),
			RING_CGETS_CRMENU(CM_MNG_PANEDWND_M),
			TRUE,
			(void (*)()) NULL,
			UxC_panedWindow,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_ROWCOLUMN),
			RING_CGETS_CRMENU(CM_MNG_ROWCOLUMN_M),
			TRUE,
			(void (*)()) NULL,
			UxC_rowColumn,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_SCALE),
			RING_CGETS_CRMENU(CM_MNG_SCALE_M),
			TRUE,
			(void (*)()) NULL,
			UxC_scale,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_SCRLWND),
			RING_CGETS_CRMENU(CM_MNG_SCRLWND_M),
			TRUE,
			(void (*)()) NULL,
			UxC_scrolledWindow,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_SELBOX),
			RING_CGETS_CRMENU(CM_MNG_SELBOX_M),
			TRUE,
			(void (*)()) NULL,
			UxC_selectionBox,
			(void (*)()) NULL );
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyTopDialogsMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Dialogs creation menu
 *		of the Main Project Window.
 * LAST REV:	jan 96 fix10723	Used RING_CGETS_CRMENU.
 *----------------------------------------------------------------------------*/
void	UxSpecifyTopDialogsMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
	extern	Class_t UxC_bulletinBoardDialog,
    			UxC_errorDialog,
    			UxC_fileSelectionBoxDialog,
    			UxC_formDialog,
    			UxC_informationDialog,
    			UxC_messageBoxDialog,
    			UxC_promptDialog,
    			UxC_questionDialog,
    			UxC_selectionBoxDialog,
    			UxC_templateDialog,
    			UxC_warningDialog,
    			UxC_workingDialog;

	TopDialogMenuCasc = casc_swgt;
	TopDialogMenuRowCol = rowcol_swgt;

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_BULTNBRD),
			RING_CGETS_CRMENU(CM_DLG_BULTNBRD_M),
			TRUE,
			(void (*)()) NULL,
			UxC_bulletinBoardDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_ERROR),
			RING_CGETS_CRMENU(CM_DLG_ERROR_M),
			TRUE,
			(void (*)()) NULL,
			UxC_errorDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_FILESELBOX),
			RING_CGETS_CRMENU(CM_DLG_FILESELBOX_M),
			TRUE,
			(void (*)()) NULL,
			UxC_fileSelectionBoxDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_FORM),
			RING_CGETS_CRMENU(CM_DLG_FORM_M),
			TRUE,
			(void (*)()) NULL,
			UxC_formDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_INFO),
			RING_CGETS_CRMENU(CM_DLG_INFO_M),
			TRUE,
			(void (*)()) NULL,
			UxC_informationDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_MSGBOX),
			RING_CGETS_CRMENU(CM_DLG_MSGBOX_M),
			TRUE,
			(void (*)()) NULL,
			UxC_messageBoxDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_PROMPT),
			RING_CGETS_CRMENU(CM_DLG_PROMPT_M),
			TRUE,
			(void (*)()) NULL,
			UxC_promptDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_QUESTION),
			RING_CGETS_CRMENU(CM_DLG_QUESTION_M),
			TRUE,
			(void (*)()) NULL,
			UxC_questionDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_SELBOX),
			RING_CGETS_CRMENU(CM_DLG_SELBOX_M),
			TRUE,
			(void (*)()) NULL,
			UxC_selectionBoxDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_TEMPL),
			RING_CGETS_CRMENU(CM_DLG_TEMPL_M),
			TRUE,
			(void (*)()) NULL,
			UxC_templateDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_WARNG),
			RING_CGETS_CRMENU(CM_DLG_WARNG_M),
			TRUE,
			(void (*)()) NULL,
			UxC_warningDialog,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_DLG_WORKG),
			RING_CGETS_CRMENU(CM_DLG_WORKG_M),
			TRUE,
			(void (*)()) NULL,
			UxC_workingDialog,
			(void (*)()) NULL );
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyTopCustomMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Custom creation menu 
 *		from the Main Project Window.
 * CREATION:	Mar 91
 *----------------------------------------------------------------------------*/
void	UxSpecifyTopCustomMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
#ifdef	HASBAE
	extern Class_t  UxC_matrix;
	extern Class_t  UxC_caption;
#endif	/* HASBAE */

	TopCustomMenuCasc = casc_swgt;
	TopCustomMenuRowCol = rowcol_swgt;

#ifdef	HASBAE
	(void) UxAddToCreateMenu(rowcol_swgt,
				 "Matrix",
				 "M",
				 TRUE,
				 (void (*)())NULL,
				 UxC_matrix,
				 (void (*)())NULL);

	(void) UxAddToCreateMenu(rowcol_swgt,
				 "Caption",
				 "C",
				 TRUE,
				 (void (*)())NULL,
				 UxC_caption,
				 (void (*)())NULL);
#endif	/* HASBAE */

#ifdef	XRT
#ifdef HASXRTGRAPH
	XrtGph_tcustmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTGRAPH */

#ifdef HASXRT3D
	Xrt3d_tcustmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRT3D */

#ifdef HASXRTTABLE
	XrtTbl_tcustmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTTABLE */
	
#ifdef HASXRTFIELD
	XrtFld_tcustmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTFIELD */

#ifdef HASXRTGEAR
	XrtGear_tcustmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTGEAR */

#ifdef HASXRTGAUGE
	XrtGauge_tcustmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTGAUGE */
#endif	/* XRT */
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyPrimitivesMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Widget creation menu popup
 *		over the widget.
 * LAST REV:	jan 96 fix10723	Used RING_CGETS_CRMENU.
 *----------------------------------------------------------------------------*/
void	UxSpecifyPrimitivesMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
	extern	Class_t	UxC_arrowButton,
			UxC_drawnButton,
			UxC_label,
			UxC_list,
			UxC_pushButton,
			UxC_scrollBar,
			UxC_scrolledList,
			UxC_scrolledText,
			UxC_separator,
			UxC_text,
			UxC_textField,
			UxC_toggleButton;

	PrimitiveMenuCasc = casc_swgt;
	PrimitiveMenuRowCol = rowcol_swgt;

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_ARROWBUTTON),
			RING_CGETS_CRMENU(CM_PRM_ARROWBUTTON_M),
			FALSE,
			(void (*)()) NULL,
			UxC_arrowButton,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_DRAWNBUTTON),
			RING_CGETS_CRMENU(CM_PRM_DRAWNBUTTON_M),
			FALSE,
			(void (*)()) NULL,
			UxC_drawnButton,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_LABEL),
			RING_CGETS_CRMENU(CM_PRM_LABEL_M),
			FALSE,
			(void (*)()) NULL,
			UxC_label,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_LIST),
			RING_CGETS_CRMENU(CM_PRM_LIST_M),
			FALSE,
			(void (*)()) NULL,
			UxC_list,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_PUSHBUTTON),
			RING_CGETS_CRMENU(CM_PRM_PUSHBUTTON_M),
			FALSE,
			(void (*)()) NULL,
			UxC_pushButton,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_SCRLBAR),
			RING_CGETS_CRMENU(CM_PRM_SCRLBAR_M),
			FALSE,
			(void (*)()) NULL,
			UxC_scrollBar,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_SCRLIST),
			RING_CGETS_CRMENU(CM_PRM_SCRLIST_M),
			FALSE,
			(void (*)()) NULL,
			UxC_scrolledList,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_SCRLTEXT),
			RING_CGETS_CRMENU(CM_PRM_SCRLTEXT_M),
			FALSE,
			(void (*)()) NULL,
			UxC_scrolledText,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_SEPRT),
			RING_CGETS_CRMENU(CM_PRM_SEPRT_M),
			FALSE,
			(void (*)()) NULL,
			UxC_separator,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_TEXT),
			RING_CGETS_CRMENU(CM_PRM_TEXT_M),
			FALSE,
			(void (*)()) NULL,
			UxC_text,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_TEXTF),
			RING_CGETS_CRMENU(CM_PRM_TEXTF_M),
			FALSE,
			(void (*)()) NULL,
			UxC_textField,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_PRM_TGLBTN),
			RING_CGETS_CRMENU(CM_PRM_TGLBTN_M),
			FALSE,
			(void (*)()) NULL,
			UxC_toggleButton,
			(void (*)()) NULL );
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyGadgetsMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Gadget creation menu popup
 *		over the Widget.
 * LAST REV:	jan 96 fix10723	Used RING_CGETS_CRMENU.
 *----------------------------------------------------------------------------*/
void	UxSpecifyGadgetsMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
    	extern 	Class_t	 UxC_arrowButtonGadget,
			 UxC_labelGadget,
			 UxC_pushButtonGadget,
			 UxC_separatorGadget,
			 UxC_toggleButtonGadget;

	GadgetMenuCasc = casc_swgt;
	GadgetMenuRowCol = rowcol_swgt;

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_GDG_ARRWBTN),
			RING_CGETS_CRMENU(CM_GDG_ARRWBTN_M),
			FALSE,
			(void (*)()) NULL,
			UxC_arrowButtonGadget,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_GDG_LABEL),
			RING_CGETS_CRMENU(CM_GDG_LABEL_M),
			FALSE,
			(void (*)()) NULL,
			UxC_labelGadget,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_GDG_PUSHBTN),
			RING_CGETS_CRMENU(CM_GDG_PUSHBTN_M),
			FALSE,
			(void (*)()) NULL,
			UxC_pushButtonGadget,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_GDG_SEPRT),
			RING_CGETS_CRMENU(CM_GDG_SEPRT_M),
			FALSE,
			(void (*)()) NULL,
			UxC_separatorGadget,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_GDG_TGLBTN),
			RING_CGETS_CRMENU(CM_GDG_TGLBTN_M),
			FALSE,
			(void (*)()) NULL,
			UxC_toggleButtonGadget,
			(void (*)()) NULL );
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyManagersMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the creation menu popup
 *		for managers for the popup menu over the Widget.
 * LAST REV:	jan 96 fix10723	Used RING_CGETS_CRMENU.
 *----------------------------------------------------------------------------*/
void	UxSpecifyManagersMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
	extern	Class_t	UxC_bulletinBoard,
			UxC_command,
			UxC_drawingArea,
			UxC_fileSelectionBox,
			UxC_form,
			UxC_frame,
			UxC_mainWindow,
			UxC_messageBox,
			UxC_panedWindow,
			UxC_rowColumn,
			UxC_scale,
			UxC_scrolledWindow,
			UxC_selectionBox;
	void	UxPopupMainWindowEditor();

	ManagerMenuCasc = casc_swgt;
	ManagerMenuRowCol = rowcol_swgt;

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_BULTNBRD),
			RING_CGETS_CRMENU(CM_MNG_BULTNBRD_M),
			FALSE,
			(void (*)()) NULL,
			UxC_bulletinBoard,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_COMM),
			RING_CGETS_CRMENU(CM_MNG_COMM_M),
			FALSE,
			(void (*)()) NULL,
			UxC_command,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_DRWGAREA),
			RING_CGETS_CRMENU(CM_MNG_DRWGAREA_M),
			FALSE,
			(void (*)()) NULL,
			UxC_drawingArea,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_FILESELBOX),
			RING_CGETS_CRMENU(CM_MNG_FILESELBOX_M),
			FALSE,
			(void (*)()) NULL,
			UxC_fileSelectionBox,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_FORM),
			RING_CGETS_CRMENU(CM_MNG_FORM_M),
			FALSE,
			(void (*)()) NULL,
			UxC_form,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_FRAME),
			RING_CGETS_CRMENU(CM_MNG_FRAME_M),
			FALSE,
			(void (*)()) NULL,
			UxC_frame,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_MAINWND),
			RING_CGETS_CRMENU(CM_MNG_MAINWND_M),
			FALSE,
			(void (*)()) NULL,
			UxC_mainWindow,
			UxPopupMainWindowEditor );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_MSGBOX),
			RING_CGETS_CRMENU(CM_MNG_MSGBOX_M),
			FALSE,
			(void (*)()) NULL,
			UxC_messageBox,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_PANEDWND),
			RING_CGETS_CRMENU(CM_MNG_PANEDWND_M),
			FALSE,
			(void (*)()) NULL,
			UxC_panedWindow,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_ROWCOLUMN),
			RING_CGETS_CRMENU(CM_MNG_ROWCOLUMN_M),
			FALSE,
			(void (*)()) NULL,
			UxC_rowColumn,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_SCALE),
			RING_CGETS_CRMENU(CM_MNG_SCALE_M),
			FALSE,
			(void (*)()) NULL,
			UxC_scale,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_SCRLWND),
			RING_CGETS_CRMENU(CM_MNG_SCRLWND_M),
			FALSE,
			(void (*)()) NULL,
			UxC_scrolledWindow,
			(void (*)()) NULL );

	(void) UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MNG_SELBOX),
			RING_CGETS_CRMENU(CM_MNG_SELBOX_M),
			FALSE,
			(void (*)()) NULL,
			UxC_selectionBox,
			(void (*)()) NULL );
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyCustomMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function adds entries to the Custom creation menu popup
 *		over the widget.
 * CREATION:	Mar 91
 *----------------------------------------------------------------------------*/
void	UxSpecifyCustomMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
#ifdef	HASBAE
	extern Class_t  UxC_matrix;
	extern Class_t  UxC_caption;
#endif	/* HASBAE */

	CustomMenuCasc = casc_swgt;
	CustomMenuRowCol = rowcol_swgt;
	
#ifdef	HASBAE
	(void) UxAddToCreateMenu(rowcol_swgt,
				 "Matrix",
				 "M",
				 FALSE,
				 (void (*)())NULL,
				 UxC_matrix,
				 (void (*)())NULL);

	(void) UxAddToCreateMenu(rowcol_swgt,
				 "Caption",
				 "C",
				 FALSE,
				 (void (*)())NULL,
				 UxC_caption,
				 (void (*)())NULL);
#endif	/* HASBAE */

#ifdef	XRT
#ifdef HASXRTGRAPH
	XrtGph_custmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTGRAPH */

#ifdef HASXRT3D
	Xrt3d_custmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRT3D */

#ifdef HASXRTTABLE
	XrtTbl_custmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTTABLE */
	
#ifdef HASXRTFIELD
	XrtFld_custmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTFIELD */

#ifdef HASXRTGEAR
	XrtGear_custmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTGEAR */

#ifdef HASXRTGAUGE
	XrtGauge_custmenu(casc_swgt, rowcol_swgt);
#endif /* HASXRTGAUGE */
#endif	/* XRT */
}

/*
        "The following typedef is used in the functions that handle the 
         creation of the menu for Menu creation. The MenusContext_t structure
         holds the swidgets that make up this menu. A pointer to this structure
         is passed as client data to the two callbacks below."
*/

typedef	struct menuContext_t
{
	swidget		popup,		/* the "Popup ..." button */
			pulldown,	/* the "Pulldown ..." button */
			option;		/* the "Option ..." button */
} MenusContext_t;

/*------------------------------------------------------------------------------
 * NAME:	menus_mapCB
 * INPUT:	Widget		w	    - widget causing this callback
 *		XtPointer	client_data - pointer to MenusContext_t struct 
 *		XtPointer	call_data   - not used
 * RETURN:	void
 * DESCRIPTION:	This function is called whenever the Menus menu is mapped
 *		It will set the sensitivities of the menus according to the
 *		Widget that forced the menu to appear.
 * CREATION:	Mar 91
 *----------------------------------------------------------------------------*/
static	void	menus_mapCB( w, client_data, call_data )
	Widget		w;
	XtPointer	client_data, call_data;
{
	MenusContext_t	*context = (MenusContext_t *) client_data;
	int		popup, pulldown, option;
	void		UxDetermineMenusMenuSensitivities();

	UxDetermineMenusMenuSensitivities( &popup, &pulldown, &option );

	XtSetSensitive( UxGetWidget( context->popup ), popup );
	XtSetSensitive( UxGetWidget( context->pulldown ), pulldown );
	XtSetSensitive( UxGetWidget( context->option ), option );
}

/*------------------------------------------------------------------------------
 * NAME:	menus_destroyCB
 * INPUT:	Widget		w	    - widget causing this callback
 *		XtPointer	client_data - pointer to MenusContext_t struct 
 *		XtPointer	call_data   - not used
 * RETURN:	void
 * DESCRIPTION:	This will free the allocated data when the widget is destroyed
 * CREATION:	Mar 91
 *----------------------------------------------------------------------------*/
static	void	menus_destroyCB( w, client_data, call_data )
	Widget		w;
	XtPointer	client_data, call_data;
{
	/* We free the memory that was allocated for the
	   MenusContext_t structure */

	UxFree( (char *) client_data );
}

/*------------------------------------------------------------------------------
 * NAME:	UxSpecifyMenusMenu
 * INPUT:	swidget	casc_swgt	- The cascade button that will 
 *					  post the menu
 *		swidget	rowcol_swgt	- The rowcol which is the parent
 *					  of the menu items
 * RETURN:	void
 * DESCRIPTION:	This function will add entries to the Menus menu and also
 *		set the mapCallback for the rowcol(menu) in order
 *		to correctly set the sensitivities of the entries.
 * LAST REV:	jan 96 fix10723	Used RING_CGETS_CRMENU.
 *----------------------------------------------------------------------------*/
void	UxSpecifyMenusMenu( casc_swgt, rowcol_swgt )
	swidget	casc_swgt;
	swidget	rowcol_swgt;
{
	MenusContext_t	*context;
	extern	void	UxPopupPopupMenuEditor(),
			UxPopupPulldownMenuEditor(),
			UxPopupOptionMenuEditor();

	context = (MenusContext_t *) UxMalloc( sizeof(MenusContext_t) );

	/* Note in the following, the NULL Class_t * class indicating that
	   no sweeping out is to be done, and the use of the "before" function
	   to popup up editors for swidget creation */

	context->popup = UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MN_POPUP),
			RING_CGETS_CRMENU(CM_MN_POPUP_M),
			FALSE,
			UxPopupPopupMenuEditor,
			(Class_t) NULL,
			(void (*)()) NULL );

	context->pulldown = UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MN_PULLDOWN),
			RING_CGETS_CRMENU(CM_MN_PULLDOWN_M),
			FALSE,
			UxPopupPulldownMenuEditor,
			(Class_t) NULL,
			(void (*)()) NULL );

	context->option = UxAddToCreateMenu( rowcol_swgt,
			RING_CGETS_CRMENU(CM_MN_OPTION),
			RING_CGETS_CRMENU(CM_MN_OPTION_M),
			FALSE,
			UxPopupOptionMenuEditor,
			(Class_t) NULL,
			(void (*)()) NULL );

	/* We put a callback on the rowColumn Menu mapCallback to arrange for
	   desensitizing of the menu buttons when necessary */

	UxAdd_callback( rowcol_swgt, XmNmapCallback,
			menus_mapCB, context );

	/* The memory that was allocated above will get freed
	   in the destroy callback for the cascade */

	UxAdd_callback( casc_swgt, XmNdestroyCallback,
			menus_destroyCB, context );
}
