/*---------------------------------------------------------------------
 * $AstecId: op-menus.c,v 1.3 1998/05/11 05:19:31 yamato Exp $
 * $Source: /rcs/rcs2/customize/op-menus.c,v $
 * $Date: 1996/11/09 16:38:35 $             $Revision: 2.2.65.1 $
 *---------------------------------------------------------------------
 *  SCCSID -- @(#)op-menus.c	1.1    96/04/10 KL Group Inc.
 *------------------------------------------------------------------------------
 * 
 *
 *             Copyright (c) 1991, Visual Edge Software Ltd.
 *
 * ALL  RIGHTS  RESERVED.  Permission  to  use,  copy,  modify,  and
 * distribute  this  software  and its documentation for any purpose
 * and  without  fee  is  hereby  granted,  provided  that the above
 * copyright  notice  appear  in  all  copies  and  that  both  that
 * copyright  notice and this permission notice appear in supporting
 * documentation,  and that  the name of Visual Edge Software not be
 * used  in advertising  or publicity  pertaining to distribution of
 * the software without specific, written prior permission. The year
 * included in the notice is the year of the creation of the work.
 *--------------------------------------------------------------------
 * This file contains the function used to specify other options.
 * By default there are none.
 *-------------------------------------------------------------------*/

/*--- include files ---*/
#include <stdio.h>
#include "UxLib.h"
#include "UxPushB.h"

#include "cat_macros.h"

/*--- macro symbolic constants ---*/

/*--- macro functions ---*/

/*--- external functions ---*/

extern swidget UxGetSelectedIfac();

/*--- types ---*/

/*--- external variables ---*/

/*--- global variables ---*/

/*--- file global variables ---*/

/*--- forward declaration of static functions ---*/

#if	defined(XRT) && defined(HASXRTSNAPSHOT)
extern void XrtWidgetSnapshotCBProc();
#endif	/* defined(XRT) && defined(HASXRTSNAPSHOT) */

/*-------------------------------------------------------------------------
NAME:		UxCreateOther
INPUT:		swidget		option_menu  : The options pulldown menu
					       that will post the options.
OUTPUT:		---
RETURN:		void
DESCRIPTION:	This function adds entries to the Options menu
		in the Main Project Window.
EXT REFERENCES: ---
EXT EFFECTS:	---
CREATION:	August 93
---------------------------------------------------------------------------*/
void	UxCreateOther( option_menu )
	swidget	option_menu;
{
#if	defined(XRT) && defined(HASXRTSNAPSHOT)
	swidget xrtSnapshot;

	xrtSnapshot = UxCreatePushButton ( "xrtSnapshot", option_menu);
	UxPutLabelString( xrtSnapshot, CGETS_KL(PRINT_WIDGET_SNAPSHOT) );
	UxPutMnemonic( xrtSnapshot, CGETS_KL(PRINT_WIDGET_SNAPSHOT_M));
	UxCreateWidget( xrtSnapshot );

	UxAddCallback ( xrtSnapshot, XmNactivateCallback, 
			(XtCallbackProc) XrtWidgetSnapshotCBProc,
			(XtPointer) NULL);
#else	/* defined(XRT) && defined(HASXRTSNAPSHOT) */
	/* By default there are no other options */
#endif	/* defined(XRT) && defined(HASXRTSNAPSHOT) */
}
