/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gauge widget UIM/X integration file
 *
 *  SCCSID -- @(#)XrtGauge_conf.c	1.1    95/11/10 KL Group Inc.
 */

/******************************************************************************
				XrtGauge_conf.c
******************************************************************************/

#ifdef	HASXRTGAUGE

#include <Xm/XrtGaugeAll.h>

#ifndef	UXREGFUNC
# ifdef __STDC__
#  define UXREGFUNC(func)	UxRegisterFunction( #func, func)
# else
#  define UXREGFUNC(func)	UxRegisterFunction( "func", func)
# endif
#endif

void
XrtGauge_register_functions()
{
	UXREGFUNC(XmCreateXrtGaCircularDial);
	UXREGFUNC(XmCreateXrtGaCircularGauge);
	UXREGFUNC(XmCreateXrtGaCounter);
	UXREGFUNC(XmCreateXrtGaLEDIcon);
	UXREGFUNC(XmCreateXrtGaLEDNumerical);
	UXREGFUNC(XmCreateXrtGaLinearDial);
	UXREGFUNC(XmCreateXrtGaLinearGauge);
	UXREGFUNC(XmCreateXrtGaPercent);
	UXREGFUNC(XmCreateXrtGaCenter);
	UXREGFUNC(XmCreateXrtGaCircularScale);
	UXREGFUNC(XmCreateXrtGaFrame);
	UXREGFUNC(XmCreateXrtGaIcon);
	UXREGFUNC(XmCreateXrtGaIndicator);
	UXREGFUNC(XmCreateXrtGaItem);
	UXREGFUNC(XmCreateXrtGaLinearScale);
	UXREGFUNC(XmCreateXrtGaMarker);
	UXREGFUNC(XmCreateXrtGaNeedle);
	UXREGFUNC(XmCreateXrtGaRange);
	UXREGFUNC(XmCreateXrtGaState);
	UXREGFUNC(XmCreateXrtGaSwitch);
	UXREGFUNC(XmCreateXrtGaText);
	UXREGFUNC(XmCreateXrtGaTick);
	UXREGFUNC(XrtGaDoubleToArgVal);
}
#endif	/* HASXRTGAUGE */

XrtGauge_config()
{
#ifdef HASXRTGAUGE

	xrt_debug_enter("XrtGauge_config");

	XtInitializeWidgetClass(xmXrtGaCircularDialWidgetClass);
	XtInitializeWidgetClass(xmXrtGaCircularGaugeWidgetClass);
	XtInitializeWidgetClass(xmXrtGaLEDIconWidgetClass);
	XtInitializeWidgetClass(xmXrtGaLEDNumericalWidgetClass);
	XtInitializeWidgetClass(xmXrtGaLinearDialWidgetClass);
	XtInitializeWidgetClass(xmXrtGaLinearGaugeWidgetClass);
	XtInitializeWidgetClass(xmXrtGaPercentWidgetClass);

	XtInitializeWidgetClass(xmXrtGaCenterObjectClass);
	XtInitializeWidgetClass(xmXrtGaCircularScaleObjectClass);
	XtInitializeWidgetClass(xmXrtGaCounterObjectClass);
	XtInitializeWidgetClass(xmXrtGaFrameObjectClass);
	XtInitializeWidgetClass(xmXrtGaIconObjectClass);
	XtInitializeWidgetClass(xmXrtGaIndicatorObjectClass);
	XtInitializeWidgetClass(xmXrtGaItemObjectClass);
	XtInitializeWidgetClass(xmXrtGaLinearScaleObjectClass);
	XtInitializeWidgetClass(xmXrtGaMarkerObjectClass);
	XtInitializeWidgetClass(xmXrtGaNeedleObjectClass);
	XtInitializeWidgetClass(xmXrtGaRangeObjectClass);
	XtInitializeWidgetClass(xmXrtGaStateObjectClass);
	XtInitializeWidgetClass(xmXrtGaSwitchObjectClass);
	XtInitializeWidgetClass(xmXrtGaTextObjectClass);
	XtInitializeWidgetClass(xmXrtGaTickObjectClass);

	xrt_debug_leave("XrtGauge_config");

#endif /* HASXRTGAUGE */
}

