/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/graph widget UIM/X integration file
 *
 *  SCCSID -- @(#)XrtGph_cg.c	1.7    97/02/10 KL Group Inc.
 */

/******************************************************************************/
/*				XrtGph_cg.c				      							      */
/******************************************************************************/

#include <stdio.h>
#include "utype.h"
#include "class_info.h"


#include <Xm/XrtGraph.h>
#include "XrtGph_xtype.h"
#include "Xrt_restable.h"

static RES_INFO				XrtGraph_res[size_xrtGraphResNum];

static void
XrtGph_cgdef_resource(table, res_info_table, n, m)
XrtGphResourceDesc	*table;
RES_INFO			*res_info_table;
int 				n;
int 				m;
{
	RES_INFO	*pResInfo;

	pResInfo 				= &(res_info_table[m]);
	pResInfo->name 			= table[n].name;
	pResInfo->xt_name 		= table[n].xt_name;
	pResInfo->xt_name_def 	= table[n].xt_name_def;
	pResInfo->pass 			= (int) table[n].pass;
	pResInfo->xtype 		= table[n].type->xtype;	
	
	if (table[n].type->convert_flag == 1) {
		pResInfo->rt_conv = 1;
	}

	if (table[n].type->converter) {
		pResInfo->converter = table[n].type->converter;
	}
	
	if (table[n].type->datatype.type_graph == XRTGPH_CALLBACK) {
		pResInfo->callback = 1;
	}
}


XrtGph_cg()
{

	int							n, n_res_used;
	static WGT_CLASS_INFO		XrtGraph_class_info;

	XrtGph_init_resource_table();

	n_res_used = 0;
	for (n = 0; n < numgph_res; n++) {
		if (xrtgph_res_table[n].used) {
			XrtGph_cgdef_resource(xrtgph_res_table, XrtGraph_res,
								  n, n_res_used);
			n_res_used++;
		}
	}


	XrtGraph_class_info.name          = "XrtGraph";
	XrtGraph_class_info.filename      = "XrtGraph";
	XrtGraph_class_info.supername     = "primitive";
	XrtGraph_class_info.xt_name       = "xtXrtGraphWidgetClass";
	XrtGraph_class_info.xt_filename   = "Xm/XrtGraph.h";
	XrtGraph_class_info.resources     = XrtGraph_res;
	XrtGraph_class_info.num_resources = n_res_used;

	CgEnterWidgetClassInfo(&XrtGraph_class_info);


}
