/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/field widget UIM/X integration file
 *
 * $AstecId: UxXrtDateField.h,v 1.3 2000/06/19 08:32:22 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtDateField.h	1.10    98/11/05 KL Group Inc.
 */

/******************************************************************************
				UxXrtDateField.h
******************************************************************************/

#ifndef UXXRTDATEFIELD_INCLUDED
#define UXXRTDATEFIELD_INCLUDED

#include <Xm/XrtField.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxXrtField.h"
#include "UxXrtDateField.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XRTDATFLD_NAME(x)	xrtflddat_res_table[x].name
#define XRTDATFLD_PRPTY(x)	xrtflddat_res_table[x].prpty
#define XRTDATFLD_TABLE(x)	XRTDATFLD_PRPTY(x), XRTDATFLD_NAME(x)

/* Design-Time UxGet and UxPut macros for xrtFldCounterIncrement */
#ifndef UxGetXrtDateFldCounterIncrement
#define UxGetXrtDateFldCounterIncrement(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumCounterIncrement))
#endif
#ifndef UxPutXrtDateFldCounterIncrement
#define UxPutXrtDateFldCounterIncrement(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumCounterIncrement), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDefaultValue */
#ifndef UxGetXrtDateFldDefaultValue
#define UxGetXrtDateFldDefaultValue(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumDefaultValue))
#endif
#ifndef UxPutXrtDateFldDefaultValue
#define UxPutXrtDateFldDefaultValue(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumDefaultValue), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDisplayFormatString */
#ifndef UxGetXrtDateFldDisplayFormatString
#define UxGetXrtDateFldDisplayFormatString(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumDisplayFormatString))
#endif
#ifndef UxPutXrtDateFldDisplayFormatString
#define UxPutXrtDateFldDisplayFormatString(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumDisplayFormatString), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldEnterFormatList */
#ifndef UxGetXrtDateFldEnterFormatList
#define UxGetXrtDateFldEnterFormatList(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumEnterFormatList))
#endif
#ifndef UxPutXrtDateFldEnterFormatList
#define UxPutXrtDateFldEnterFormatList(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumEnterFormatList), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldInternalValue */
#ifndef UxGetXrtDateFldInternalValue
#define UxGetXrtDateFldInternalValue(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumInternalValue))
#endif
#ifndef UxPutXrtDateFldInternalValue
#define UxPutXrtDateFldInternalValue(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumInternalValue), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldInternalValueLong */
#ifndef UxGetXrtDateFldInternalValueLong
#define UxGetXrtDateFldInternalValueLong(sw) \
	UxGET_long(sw, XRTDATFLD_TABLE(xrtDateFldResNumInternalValueLong))
#endif
#ifndef UxPutXrtDateFldInternalValueLong
#define UxPutXrtDateFldInternalValueLong(sw, val) \
	UxPUT_long(sw, XRTDATFLD_TABLE(xrtDateFldResNumInternalValueLong), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldMax */
#ifndef UxGetXrtDateFldMax
#define UxGetXrtDateFldMax(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumMax))
#endif
#ifndef UxPutXrtDateFldMax
#define UxPutXrtDateFldMax(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumMax), val)
#endif

/* (pds) Design-Time UxGet and UxPut macros for xrtFldMilleniumThreshold */
#ifndef UxGetXrtDateFldMilleniumThreshold
#define UxGetXrtDateFldMilleniumThreshold(sw) \
	UxGET_int(sw, XRTDATFLD_TABLE(xrtDateFldResNumMilleniumThreshold))
#endif
#ifndef UxPutXrtDateFldMilleniumThreshold
#define UxPutXrtDateFldMilleniumThreshold(sw, val) \
	UxPUT_int(sw, XRTDATFLD_TABLE(xrtDateFldResNumMilleniumThreshold), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldMin */
#ifndef UxGetXrtDateFldMin
#define UxGetXrtDateFldMin(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumMin))
#endif
#ifndef UxPutXrtDateFldMin
#define UxPutXrtDateFldMin(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumMin), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldPickList */
#ifndef UxGetXrtDateFldPickList
#define UxGetXrtDateFldPickList(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumPickList))
#endif
#ifndef UxPutXrtDateFldPickList
#define UxPutXrtDateFldPickList(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumPickList), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtDateFldCalendar */
#ifndef UxGetXrtDateFldCalendar
#define UxGetXrtDateFldCalendar(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumCalendar))
#endif
#ifndef UxPutXrtDateFldCalendar
#define UxPutXrtDateFldCalendar(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumCalendar), val)
#endif

/* Design-Time UxGet and UxPut macros for XrtDateFldSpinPolicy */
#ifndef UxGetXrtDateFldSpinPolicy
#define UxGetXrtDateFldSpinPolicy(sw) \
	UxGET_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumSpinPolicy))
#endif
#ifndef UxPutXrtDateFldSpinPolicy
#define UxPutXrtDateFldSpinPolicy(sw, val) \
	UxPUT_string(sw, XRTDATFLD_TABLE(xrtDateFldResNumSpinPolicy), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtDateField;

/* Design-time create macro */
#ifndef UxCreateXrtDateField
#define UxCreateXrtDateField(name, parent) \
	UxCreateSwidget(UxC_XrtDateField, name, parent)
#endif

#else /* Not DESIGN_TIME */

#ifndef UxGetXrtDateFldCounterIncrement
#define UxGetXrtDateFldCounterIncrement(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldCounterIncrement)
#endif
#ifndef UxPutXrtDateFldCounterIncrement
#define UxPutXrtDateFldCounterIncrement(sw, val) \
	UxDDPutProp(sw, XmNxrtFldCounterIncrement, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldDefaultValue
#define UxGetXrtDateFldDefaultValue(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldDefaultValue)
#endif
#ifndef UxPutXrtDateFldDefaultValue
#define UxPutXrtDateFldDefaultValue(sw, val) \
	UxDDPutProp(sw, XmNxrtFldDefaultValue, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldDisplayFormatString
#define UxGetXrtDateFldDisplayFormatString(sw) \
	(char *) UxGetProp(sw, XmNxrtFldDisplayFormatString)
#endif
#ifndef UxPutXrtDateFldDisplayFormatString
#define UxPutXrtDateFldDisplayFormatString(sw, val) \
	UxPutProp(sw, XmNxrtFldDisplayFormatString, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldEnterFormatList
#define UxGetXrtDateFldEnterFormatList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldEnterFormatList)
#endif
#ifndef UxPutXrtDateFldEnterFormatList
#define UxPutXrtDateFldEnterFormatList(sw, val) \
	UxDDPutProp(sw, XmNxrtFldEnterFormatList, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldInternalValue
#define UxGetXrtDateFldInternalValue(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldInternalValue)
#endif
#ifndef UxPutXrtDateFldInternalValue
#define UxPutXrtDateFldInternalValue(sw, val) \
	UxDDPutProp(sw, XmNxrtFldInternalValue, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldInternalValueLong
#define UxGetXrtDateFldInternalValueLong(sw) \
	(long) UxGetProp(sw, XmNxrtFldInternalValueLong)
#endif
#ifndef UxPutXrtDateFldInternalValueLong
#define UxPutXrtDateFldInternalValueLong(sw, val) \
	UxPutProp(sw, XmNxrtFldInternalValueLong, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldMax
#define UxGetXrtDateFldMax(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldMax)
#endif
#ifndef UxPutXrtDateFldMax
#define UxPutXrtDateFldMax(sw, val) \
	UxDDPutProp(sw, XmNxrtFldMax, (XtArgVal)(val))
#endif
/* pds */ 
#ifndef UxGetXrtDateFldMilleniumThreshold
#define UxGetXrtDateFldMilleniumThreshold(sw) \
	(int)UxIntGetProp(sw, XmNxrtFldMilleniumThreshold)
#endif
#ifndef UxPutXrtDateFldMilleniumThreshold
#define UxPutXrtDateFldMilleniumThreshold(sw, val) \
	UxPutProp(sw, XmNxrtFldMilleniumThreshold, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldMin
#define UxGetXrtDateFldMin(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldMin)
#endif
#ifndef UxPutXrtDateFldMin
#define UxPutXrtDateFldMin(sw, val) \
	UxDDPutProp(sw, XmNxrtFldMin, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldPickList
#define UxGetXrtDateFldPickList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldPickList)
#endif
#ifndef UxPutXrtDateFldPickList
#define UxPutXrtDateFldPickList(sw, val) \
	UxDDPutProp(sw, XmNxrtFldPickList, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldCalendar
#define UxGetXrtDateFldCalendar(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldCalendar)
#endif
#ifndef UxPutXrtDateFldCalendar
#define UxPutXrtDateFldCalendar(sw, val) \
	UxDDPutProp(sw, XmNxrtFldCalendar, (XtArgVal)(val))
#endif

#ifndef UxGetXrtDateFldSpinPolicy
#define UxGetXrtDateFldSpinPolicy(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldSpinPolicy)
#endif
#ifndef UxPutXrtDateFldSpinPolicy
#define UxPutXrtDateFldSpinPolicy(sw, val) \
	UxDDPutProp(sw, XmNxrtFldSpinPolicy, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtDateField
#define UxCreateXrtDateField(name, parent) \
	UxCreateSwidget(name, xmXrtDateFieldWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTDATEFIELD_INCLUDED */

/***END*OF*FILE***************************************************************/
