/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 * $AstecId: UxXrtDateField.hxx,v 1.6 2000/06/19 08:32:22 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtDateField.hxx	1.5    98/11/05 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtDateField : public UxXrtField
{
    public:


	// Constructors
	UXINLINE UxXrtDateField(void);
	UXINLINE UxXrtDateField(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE char * GetXrtDateFldCounterIncrement () const;
	UXINLINE void SetXrtDateFldCounterIncrement (const char *);

	UXINLINE char * GetXrtDateFldDefaultValue () const;
	UXINLINE void SetXrtDateFldDefaultValue (const char *);

	UXINLINE char * GetXrtDateFldDisplayFormatString () const;
	UXINLINE void SetXrtDateFldDisplayFormatString (const char *);

	UXINLINE char * GetXrtDateFldEnterFormatList () const;
	UXINLINE void SetXrtDateFldEnterFormatList (const char *);

	UXINLINE char * GetXrtDateFldInternalValue () const;
	UXINLINE void SetXrtDateFldInternalValue (const char *);

	UXINLINE long GetXrtDateFldInternalValueLong () const;
	UXINLINE void SetXrtDateFldInternalValueLong	(long);

	UXINLINE char * GetXrtDateFldMax () const;
	UXINLINE void SetXrtDateFldMax (const char *);
	/* pds */
	UXINLINE int GetXrtDateFldMilleniumThreshold () const;
	UXINLINE void SetXrtDateFldMilleniumThreshold (int);

	UXINLINE char * GetXrtDateFldMin () const;
	UXINLINE void SetXrtDateFldMin (const char *);

	UXINLINE char * GetXrtDateFldPickList () const;
	UXINLINE void SetXrtDateFldPickList (const char *);

	UXINLINE char * GetXrtDateFldCalendar () const;
	UXINLINE void SetXrtDateFldCalendar(const char * );

	UXINLINE char * GetXrtDateFldSpinPolicy () const;
	UXINLINE void SetXrtDateFldSpinPolicy(const char *);
};

#ifdef DESIGN_TIME

#define XRTDATFLD_NAME(x)	xrtflddat_res_table[x].name
#define XRTDATFLD_PRPTY(x)	xrtflddat_res_table[x].prpty
#define XRTDATFLD_TABLE(x)	XRTDATFLD_PRPTY(x), XRTDATFLD_NAME(x)

extern Class_t UxC_XrtDateField;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// Constructors
inline UxXrtDateField::UxXrtDateField(void){}
inline UxXrtDateField::UxXrtDateField(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtDateField::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtDateFieldWidgetClass, parent);
	return UxThis;
}

inline char * UxXrtDateField::GetXrtDateFldCounterIncrement (void) const
	{ return (char * ) DDGetProp(XmNxrtFldCounterIncrement);}
inline void UxXrtDateField::SetXrtDateFldCounterIncrement (const char * val)
	{ DDSetProp(XmNxrtFldCounterIncrement, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldDefaultValue (void) const
	{ return (char * ) DDGetProp(XmNxrtFldDefaultValue);}
inline void UxXrtDateField::SetXrtDateFldDefaultValue (const char * val)
	{ DDSetProp(XmNxrtFldDefaultValue, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldDisplayFormatString (void) const
	{ return (char * ) GetProp(XmNxrtFldDisplayFormatString);}
inline void UxXrtDateField::SetXrtDateFldDisplayFormatString (const char * val)
	{ SetProp(XmNxrtFldDisplayFormatString, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldEnterFormatList (void) const
	{ return (char * ) DDGetProp(XmNxrtFldEnterFormatList);}
inline void UxXrtDateField::SetXrtDateFldEnterFormatList (const char * val)
	{ DDSetProp(XmNxrtFldEnterFormatList, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldInternalValue (void) const
	{ return (char * ) DDGetProp(XmNxrtFldInternalValue);}
inline void UxXrtDateField::SetXrtDateFldInternalValue (const char * val)
	{ DDSetProp(XmNxrtFldInternalValue, ((XtArgVal)(val)));}

inline long UxXrtDateField::GetXrtDateFldInternalValueLong (void) const
	{ return (long ) GetProp(XmNxrtFldInternalValueLong);}
inline void UxXrtDateField::SetXrtDateFldInternalValueLong	(long val)
	{ SetProp(XmNxrtFldInternalValueLong, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldMax (void) const
	{ return (char * ) DDGetProp(XmNxrtFldMax);}
inline void UxXrtDateField::SetXrtDateFldMax (const char * val)
	{ DDSetProp(XmNxrtFldMax, ((XtArgVal)(val)));}
/* pds */ 	
inline int UxXrtDateField::GetXrtDateFldMilleniumThreshold (void) const
	{ return (int)IntGetProp(XmNxrtFldMilleniumThreshold);}
inline void UxXrtDateField::SetXrtDateFldMilleniumThreshold (int val)
	{ SetProp(XmNxrtFldMilleniumThreshold, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldMin (void) const
	{ return (char * ) DDGetProp(XmNxrtFldMin);}
inline void UxXrtDateField::SetXrtDateFldMin (const char * val)
	{ DDSetProp(XmNxrtFldMin, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldPickList (void) const
	{ return (char * ) DDGetProp(XmNxrtFldPickList);}
inline void UxXrtDateField::SetXrtDateFldPickList (const char * val)
	{ DDSetProp(XmNxrtFldPickList, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldCalendar (void) const
	{ return (char *) DDGetProp(XmNxrtFldCalendar);}
inline void UxXrtDateField::SetXrtDateFldCalendar (const char * val)
	{ DDSetProp(XmNxrtFldCalendar, ((XtArgVal)(val)));}

inline char * UxXrtDateField::GetXrtDateFldSpinPolicy (void) const
	{ return (char *) DDGetProp(XmNxrtFldSpinPolicy);}
inline void UxXrtDateField::SetXrtDateFldSpinPolicy (const char * val)
	{ DDSetProp(XmNxrtFldSpinPolicy, ((XtArgVal)(val)));}

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */

