/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 * $AstecId: UxXrtField.hxx,v 1.6 2000/06/19 08:32:24 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtField.hxx	1.5    98/11/05 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtField : public UxText
{
    public:

	// Constructors
	UXINLINE UxXrtField(void);
	UXINLINE UxXrtField(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE char * GetXrtFldAllowNull () const;
	UXINLINE void SetXrtFldAllowNull (const char *);

	UXINLINE char * GetXrtFldCase () const;
	UXINLINE void SetXrtFldCase (const char *);

	UXINLINE char * GetXrtFldDefaultBackground () const;
	UXINLINE void SetXrtFldDefaultBackground (const char *);

	UXINLINE char * GetXrtFldDefaultForeground () const;
	UXINLINE void SetXrtFldDefaultForeground (const char *);

	UXINLINE char * GetXrtFldDisplayFormat () const;
	UXINLINE void SetXrtFldDisplayFormat (const char *);

	UXINLINE char * GetXrtFldDisplayHorizScrollBar () const;
	UXINLINE void SetXrtFldDisplayHorizScrollBar (const char *);

	UXINLINE char * GetXrtFldDisplayVertScrollBar () const;
	UXINLINE void SetXrtFldDisplayVertScrollBar (const char *);

	UXINLINE char * GetXrtFldEditFormat () const;
	UXINLINE void SetXrtFldEditFormat (const char *);

	UXINLINE char * GetXrtFldErrorBackground () const;
	UXINLINE void SetXrtFldErrorBackground (const char *);

	UXINLINE char * GetXrtFldErrorForeground () const;
	UXINLINE void SetXrtFldErrorForeground (const char *);

	UXINLINE char * GetXrtFldErrorString () const;
	UXINLINE void SetXrtFldErrorString (const char *);

	UXINLINE char * GetXrtFldInvalidChars () const;
	UXINLINE void SetXrtFldInvalidChars (const char *);

	UXINLINE char * GetXrtFldIsDefault () const;
	UXINLINE void SetXrtFldIsDefault (const char *);

	UXINLINE char * GetXrtFldIsModified () const;
	UXINLINE void SetXrtFldIsModified (const char *);

	UXINLINE char * GetXrtFldIsValid () const;
	UXINLINE void SetXrtFldIsValid (const char *);

	UXINLINE char * GetXrtFldLastError () const;
	UXINLINE void SetXrtFldLastError (const char *);

	UXINLINE char * GetXrtFldMask () const;
	UXINLINE void SetXrtFldMask (const char *);

	UXINLINE char * GetXrtFldMaskChars () const;
	UXINLINE void SetXrtFldMaskChars (const char *);

	UXINLINE char * GetXrtFldMatchMask () const;
	UXINLINE void SetXrtFldMatchMask (const char *);

	UXINLINE char * GetXrtFldMatchPickList () const;
	UXINLINE void SetXrtFldMatchPickList (const char *);

	UXINLINE int GetXrtFldMaxLineLength () const;
	UXINLINE void SetXrtFldMaxLineLength (int);

	UXINLINE int GetXrtFldMaxLines () const;
	UXINLINE void SetXrtFldMaxLines (int);
	/* pds */ 
	UXINLINE char * GetXrtFldMenuAlignment () const;
	UXINLINE void SetXrtFldMenuAlignment (const char *);

	// UXINLINE char * GetXrtFldMenuList () const;
	// UXINLINE void SetXrtFldMenuList (const char *);

	UXINLINE char * GetXrtFldOverstrike () const;
	UXINLINE void SetXrtFldOverstrike (const char *);

	UXINLINE int GetXrtFldPickListIndex () const;
	UXINLINE void SetXrtFldPickListIndex (int);

	UXINLINE char * GetXrtFldPromptString () const;
	UXINLINE void SetXrtFldPromptString (const char *);

	UXINLINE char * GetXrtFldRange () const;
	UXINLINE void SetXrtFldRange (const char *);
	/* pds */ 
	UXINLINE char * GetXrtFldSearchPolicy () const;
	UXINLINE void SetXrtFldSearchPolicy (const char *);

	UXINLINE char * GetXrtFldValidChars () const;
	UXINLINE void SetXrtFldValidChars (const char *);

	UXINLINE int GetXrtFldVisibleItemCount () const;
	UXINLINE void SetXrtFldVisibleItemCount (int);

	UXINLINE char * GetXrtFldAutoComplete () const;
	UXINLINE void SetXrtFldAutoComplete(const char *);

	UXINLINE char * GetXrtFldCreatePopups () const;
	UXINLINE void SetXrtFldCreatePopups(const char *);

	UXINLINE char * GetXrtFldPopupType () const;
	UXINLINE void SetXrtFldPopupType(const char *l);
};

#ifdef DESIGN_TIME

#define XRTFLD_TABLE(x)	xrtfld_res_table[x].prpty, xrtfld_res_table[x].name

extern Class_t UxC_XrtField;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// Constructors
inline UxXrtField::UxXrtField(void){}
inline UxXrtField::UxXrtField(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtField::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtFieldWidgetClass, parent);
	return UxThis;
}

inline char * UxXrtField::GetXrtFldAllowNull (void) const
	{ return (char * ) DDGetProp(XmNxrtFldAllowNull);}
inline void UxXrtField::SetXrtFldAllowNull (const char * val)
	{ DDSetProp(XmNxrtFldAllowNull, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldCase (void) const
	{ return (char * ) DDGetProp(XmNxrtFldCase);}
inline void UxXrtField::SetXrtFldCase (const char * val)
	{ DDSetProp(XmNxrtFldCase, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldDefaultBackground (void) const
	{ return (char * ) DDGetProp(XmNxrtFldDefaultBackground);}
inline void UxXrtField::SetXrtFldDefaultBackground (const char * val)
	{ DDSetProp(XmNxrtFldDefaultBackground, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldDefaultForeground (void) const
	{ return (char * ) DDGetProp(XmNxrtFldDefaultForeground);}
inline void UxXrtField::SetXrtFldDefaultForeground (const char * val)
	{ DDSetProp(XmNxrtFldDefaultForeground, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldDisplayFormat (void) const
	{ return (char * ) DDGetProp(XmNxrtFldDisplayFormat);}
inline void UxXrtField::SetXrtFldDisplayFormat (const char * val)
	{ DDSetProp(XmNxrtFldDisplayFormat, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldDisplayHorizScrollBar (void) const
	{ return (char * ) DDGetProp(XmNxrtFldDisplayHorizScrollBar);}
inline void UxXrtField::SetXrtFldDisplayHorizScrollBar (const char * val)
	{ DDSetProp(XmNxrtFldDisplayHorizScrollBar, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldDisplayVertScrollBar (void) const
	{ return (char * ) DDGetProp(XmNxrtFldDisplayVertScrollBar);}
inline void UxXrtField::SetXrtFldDisplayVertScrollBar (const char * val)
	{ DDSetProp(XmNxrtFldDisplayVertScrollBar, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldEditFormat (void) const
	{ return (char * ) DDGetProp(XmNxrtFldEditFormat);}
inline void UxXrtField::SetXrtFldEditFormat (const char * val)
	{ DDSetProp(XmNxrtFldEditFormat, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldErrorBackground (void) const
	{ return (char * ) DDGetProp(XmNxrtFldErrorBackground);}
inline void UxXrtField::SetXrtFldErrorBackground (const char * val)
	{ DDSetProp(XmNxrtFldErrorBackground, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldErrorForeground (void) const
	{ return (char * ) DDGetProp(XmNxrtFldErrorForeground);}
inline void UxXrtField::SetXrtFldErrorForeground (const char * val)
	{ DDSetProp(XmNxrtFldErrorForeground, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldErrorString (void) const
	{ return (char * ) DDGetProp(XmNxrtFldErrorString);}
inline void UxXrtField::SetXrtFldErrorString (const char * val)
	{ DDSetProp(XmNxrtFldErrorString, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldInvalidChars (void) const
	{ return (char * ) GetProp(XmNxrtFldInvalidChars);}
inline void UxXrtField::SetXrtFldInvalidChars (const char * val) 
	{ SetProp(XmNxrtFldInvalidChars, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldIsDefault (void) const
	{ return (char * ) GetProp(XmNxrtFldIsDefault);}
inline void UxXrtField::SetXrtFldIsDefault (const char * val)
	{ DDSetProp(XmNxrtFldIsDefault, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldIsModified (void) const
	{ return (char * ) DDGetProp(XmNxrtFldIsModified);}
inline void UxXrtField::SetXrtFldIsModified (const char * val)
	{ DDSetProp(XmNxrtFldIsModified, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldIsValid (void) const
	{ return (char * ) DDGetProp(XmNxrtFldIsValid);}
inline void UxXrtField::SetXrtFldIsValid (const char * val)
	{ DDSetProp(XmNxrtFldIsValid, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldLastError (void) const
	{ return (char * ) DDGetProp(XmNxrtFldLastError);}
inline void UxXrtField::SetXrtFldLastError (const char * val)
	{ DDSetProp(XmNxrtFldLastError, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldMask (void) const
	{ return (char * ) GetProp(XmNxrtFldMask);}
inline void UxXrtField::SetXrtFldMask (const char * val)
	{ SetProp(XmNxrtFldMask, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldMaskChars (void) const
	{ return (char * ) GetProp(XmNxrtFldMaskChars);}
inline void UxXrtField::SetXrtFldMaskChars (const char * val) 
	{ SetProp(XmNxrtFldMaskChars, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldMatchMask (void) const
	{ return (char * ) GetProp(XmNxrtFldMatchMask);}
inline void UxXrtField::SetXrtFldMatchMask (const char * val)
	{ SetProp(XmNxrtFldMatchMask, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldMatchPickList (void) const
	{ return (char * ) DDGetProp(XmNxrtFldMatchPickList);}
inline void UxXrtField::SetXrtFldMatchPickList (const char * val)
	{ DDSetProp(XmNxrtFldMatchPickList, ((XtArgVal)(val)));}

inline int UxXrtField::GetXrtFldMaxLineLength (void) const
	{ return (int)IntGetProp(XmNxrtFldMaxLineLength);}
inline void UxXrtField::SetXrtFldMaxLineLength	(int val)
	{ SetProp(XmNxrtFldMaxLineLength, ((XtArgVal)(val)));}

inline int UxXrtField::GetXrtFldMaxLines (void) const
	{ return (int)IntGetProp(XmNxrtFldMaxLines);}
inline void UxXrtField::SetXrtFldMaxLines (int val)
	{ SetProp(XmNxrtFldMaxLines, ((XtArgVal)(val)));}
/* pds */ 	
inline char * UxXrtField::GetXrtFldMenuAlignment (void) const
	{ return (char * ) DDGetProp(XmNxrtFldMenuAlignment);}
inline void UxXrtField::SetXrtFldMenuAlignment (const char * val)
	{ DDSetProp(XmNxrtFldMenuAlignment, ((XtArgVal)(val)));}

// inline char * UxXrtField::GetXrtFldMenuList (void) const
// 	{ return (char * ) DDGetProp(XmNxrtFldMenutList);}
// inline void UxXrtField::SetXrtFldMenuList (const char * val)
// 	{ DDSetProp(XmNxrtFldMenu,List ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldOverstrike (void) const
	{ return (char * ) DDGetProp(XmNxrtFldOverstrike);}
inline void UxXrtField::SetXrtFldOverstrike (const char * val)
	{ DDSetProp(XmNxrtFldOverstrike, ((XtArgVal)(val)));}

inline int UxXrtField::GetXrtFldPickListIndex (void) const
	{ return (int)IntGetProp(XmNxrtFldPickListIndex);}
inline void UxXrtField::SetXrtFldPickListIndex (int val)
	{ SetProp(XmNxrtFldPickListIndex, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldPromptString (void) const
	{ return (char * ) GetProp(XmNxrtFldPromptString);}
inline void UxXrtField::SetXrtFldPromptString (const char * val)
	{ DDSetProp(XmNxrtFldPromptString, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldRange (void) const
	{ return (char * ) DDGetProp(XmNxrtFldRange);}
inline void UxXrtField::SetXrtFldRange (const char * val)
	{ DDSetProp(XmNxrtFldRange, ((XtArgVal)(val)));}
/* pds */ 
inline char * UxXrtField::GetXrtFldSearchPolicy (void) const
	{ return (char * ) DDGetProp(XmNxrtFldSearchPolicy);}
inline void UxXrtField::SetXrtFldSearchPolicy (const char * val)
	{ DDSetProp(XmNxrtFldSearchPolicy, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldValidChars (void) const
	{ return (char * ) GetProp(XmNxrtFldValidChars);}
inline void UxXrtField::SetXrtFldValidChars (const char * val)
	{ SetProp(XmNxrtFldValidChars, ((XtArgVal)(val)));}

inline int UxXrtField::GetXrtFldVisibleItemCount (void) const
	{ return (int)IntGetProp(XmNxrtFldVisibleItemCount);}
inline void UxXrtField::SetXrtFldVisibleItemCount (int val)
	{ SetProp(XmNxrtFldVisibleItemCount, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldAutoComplete (void) const
	{ return (char *) DDGetProp(XmNxrtFldAutoComplete);}
inline void UxXrtField::SetXrtFldAutoComplete (const char * val)
	{ DDSetProp(XmNxrtFldAutoComplete, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldCreatePopups (void) const
	{ return (char *) DDGetProp(XmNxrtFldCreatePopups);}
inline void UxXrtField::SetXrtFldCreatePopups (const char * val)
	{ DDSetProp(XmNxrtFldCreatePopups, ((XtArgVal)(val)));}

inline char * UxXrtField::GetXrtFldPopupType (void) const
	{ return (char *) DDGetProp(XmNxrtFldPopupType);}
inline void UxXrtField::SetXrtFldPopupType (const char * val)
	{ DDSetProp(XmNxrtFldPopupType, ((XtArgVal)(val)));}

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */
