/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/field widget UIM/X integration file
 *
 *  $AstecId: UxXrtFloatField.h,v 1.4 2000/06/19 08:32:25 kosaka Exp $
 *  SCCSID -- @(#)UxXrtFloatField.h	1.6    95/06/16 KL Group Inc.
 */

/******************************************************************************
				UxXrtFloatField.h
******************************************************************************/

#ifndef UXXRTFLOATFIELD_INCLUDED
#define UXXRTFLOATFIELD_INCLUDED

#include <Xm/XrtField.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxXrtField.h"
#include "UxXrtFloatField.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XRTFLTFLD_NAME(x)	xrtfldflt_res_table[x].name
#define XRTFLTFLD_PRPTY(x)	xrtfldflt_res_table[x].prpty
#define XRTFLTFLD_TABLE(x)	XRTFLTFLD_PRPTY(x), XRTFLTFLD_NAME(x)

#ifdef hp700v9
#define XrtFldDoubleToArgVal(d) UxXrtFldDoubleToArgVal(0,d)
#endif /* hp700v9 */

/* Design-Time UxGet and UxPut macros for xrtFldCounterIncrement */
#ifndef UxGetXrtFloatFldCounterIncrement
#define UxGetXrtFloatFldCounterIncrement(sw) \
	UxXrtGET_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumCounterIncrement))
#endif
#ifndef UxPutXrtFloatFldCounterIncrement
#define UxPutXrtFloatFldCounterIncrement(sw, val) \
	UxXrtPUT_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumCounterIncrement), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDecimalPlaces */
#ifndef UxGetXrtFloatFldDecimalPlaces
#define UxGetXrtFloatFldDecimalPlaces(sw) \
	UxGET_int(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumDecimalPlaces))
#endif
#ifndef UxPutXrtFloatFldDecimalPlaces
#define UxPutXrtFloatFldDecimalPlaces(sw, val) \
	UxPUT_int(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumDecimalPlaces), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDefaultValue */
#ifndef UxGetXrtFloatFldDefaultValue
#define UxGetXrtFloatFldDefaultValue(sw) \
	UxXrtGET_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumDefaultValue))
#endif
#ifndef UxPutXrtFloatFldDefaultValue
#define UxPutXrtFloatFldDefaultValue(sw, val) \
	UxXrtPUT_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumDefaultValue), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldDisplayFormatString */
#ifndef UxGetXrtFloatFldDisplayFormatString
#define UxGetXrtFloatFldDisplayFormatString(sw) \
	UxGET_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumDisplayFormatString))
#endif
#ifndef UxPutXrtFloatFldDisplayFormatString
#define UxPutXrtFloatFldDisplayFormatString(sw, val) \
	UxPUT_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumDisplayFormatString), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldInternalValue */
#ifndef UxGetXrtFloatFldInternalValue
#define UxGetXrtFloatFldInternalValue(sw) \
	UxXrtGET_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumInternalValue))
#endif
#ifndef UxPutXrtFloatFldInternalValue
#define UxPutXrtFloatFldInternalValue(sw, val) \
	UxXrtPUT_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumInternalValue), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldLeadingZero */
#ifndef UxGetXrtFloatFldLeadingZero
#define UxGetXrtFloatFldLeadingZero(sw) \
	UxGET_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumLeadingZero))
#endif
#ifndef UxPutXrtFloatFldLeadingZero
#define UxPutXrtFloatFldLeadingZero(sw, val) \
	UxPUT_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumLeadingZero), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldMax */
#ifndef UxGetXrtFloatFldMax
#define UxGetXrtFloatFldMax(sw) \
	UxXrtGET_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumMax))
#endif
#ifndef UxPutXrtFloatFldMax
#define UxPutXrtFloatFldMax(sw, val) \
	UxXrtPUT_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumMax), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldMin */
#ifndef UxGetXrtFloatFldMin
#define UxGetXrtFloatFldMin(sw) \
	UxXrtGET_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumMin))
#endif
#ifndef UxPutXrtFloatFldMin
#define UxPutXrtFloatFldMin(sw, val) \
	UxXrtPUT_double(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumMin), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldNegativeFormat */
#ifndef UxGetXrtFloatFldNegativeFormat
#define UxGetXrtFloatFldNegativeFormat(sw) \
	UxGET_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumNegativeFormat))
#endif
#ifndef UxPutXrtFloatFldNegativeFormat
#define UxPutXrtFloatFldNegativeFormat(sw, val) \
	UxPUT_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumNegativeFormat), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtFldPickList */
#ifndef UxGetXrtFloatFldPickList
#define UxGetXrtFloatFldPickList(sw) \
	UxGET_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumPickList))
#endif
#ifndef UxPutXrtFloatFldPickList
#define UxPutXrtFloatFldPickList(sw, val) \
	UxPUT_string(sw, XRTFLTFLD_TABLE(xrtFloatFldResNumPickList), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtFloatField;
/* Design-time create macro */
#ifndef UxCreateXrtFloatField
#define UxCreateXrtFloatField(name, parent) \
	UxCreateSwidget(UxC_XrtFloatField, name, parent)
#endif

#else /* Not DESIGN_TIME */

extern XtArgVal UxGetXrtFldDoubleProp	UXPROTO((swidget, char *));
extern double   XrtFldArgValToDouble	UXPROTO((XtArgVal));
extern XtArgVal XrtFldDoubleToArgVal	UXPROTO((double));

#define RT_FLD_GET_DOUBLE(sw,res) \
	XrtFldArgValToDouble(UxGetXrtFldDoubleProp(sw,res))

#define RT_FLD_PUT_DOUBLE(sw,res,val) \
	UxPutProp(sw,res,(XtArgVal)XrtFldDoubleToArgVal((double)val))

#ifndef UxGetXrtFloatFldCounterIncrement
#define UxGetXrtFloatFldCounterIncrement(sw) \
	RT_FLD_GET_DOUBLE(sw, XmNxrtFldCounterIncrement)
#endif
#ifndef UxPutXrtFloatFldCounterIncrement
#define UxPutXrtFloatFldCounterIncrement(sw, val) \
	RT_FLD_PUT_DOUBLE(sw, XmNxrtFldCounterIncrement, val)
#endif

#ifndef UxGetXrtFloatFldDecimalPlaces
#define UxGetXrtFloatFldDecimalPlaces(sw) \
	(int)UxIntGetProp(sw, XmNxrtFldDecimalPlaces)
#endif
#ifndef UxPutXrtFloatFldDecimalPlaces
#define UxPutXrtFloatFldDecimalPlaces(sw, val) \
	UxPutProp(sw, XmNxrtFldDecimalPlaces, (XtArgVal)(val))
#endif

#ifndef UxGetXrtFloatFldDefaultValue
#define UxGetXrtFloatFldDefaultValue(sw) \
	RT_FLD_GET_DOUBLE(sw, XmNxrtFldDefaultValue)
#endif
#ifndef UxPutXrtFloatFldDefaultValue
#define UxPutXrtFloatFldDefaultValue(sw, val) \
	RT_FLD_PUT_DOUBLE(sw, XmNxrtFldDefaultValue, val)
#endif

#ifndef UxGetXrtFloatFldDisplayFormatString
#define UxGetXrtFloatFldDisplayFormatString(sw) \
	(char *) UxGetProp(sw, XmNxrtFldDisplayFormatString)
#endif
#ifndef UxPutXrtFloatFldDisplayFormatString
#define UxPutXrtFloatFldDisplayFormatString(sw, val) \
	UxPutProp(sw, XmNxrtFldDisplayFormatString, (XtArgVal)(val))
#endif

#ifndef UxGetXrtFloatFldInternalValue
#define UxGetXrtFloatFldInternalValue(sw) \
	RT_FLD_GET_DOUBLE(sw, XmNxrtFldInternalValue)
#endif
#ifndef UxPutXrtFloatFldInternalValue
#define UxPutXrtFloatFldInternalValue(sw, val) \
	RT_FLD_PUT_DOUBLE(sw, XmNxrtFldInternalValue, val)
#endif

#ifndef UxGetXrtFloatFldLeadingZero
#define UxGetXrtFloatFldLeadingZero(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldLeadingZero)
#endif
#ifndef UxPutXrtFloatFldLeadingZero
#define UxPutXrtFloatFldLeadingZero(sw, val) \
	UxDDPutProp(sw, XmNxrtFldLeadingZero, (XtArgVal)(val))
#endif

#ifndef UxGetXrtFloatFldMax
#define UxGetXrtFloatFldMax(sw) \
	RT_FLD_GET_DOUBLE(sw, XmNxrtFldMax)
#endif
#ifndef UxPutXrtFloatFldMax
#define UxPutXrtFloatFldMax(sw, val) \
	RT_FLD_PUT_DOUBLE(sw, XmNxrtFldMax, val)
#endif

#ifndef UxGetXrtFloatFldMin
#define UxGetXrtFloatFldMin(sw) \
	RT_FLD_GET_DOUBLE(sw, XmNxrtFldMin)
#endif
#ifndef UxPutXrtFloatFldMin
#define UxPutXrtFloatFldMin(sw, val) \
	RT_FLD_PUT_DOUBLE(sw, XmNxrtFldMin, val)
#endif

#ifndef UxGetXrtFloatFldNegativeFormat
#define UxGetXrtFloatFldNegativeFormat(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldNegativeFormat)
#endif
#ifndef UxPutXrtFloatFldNegativeFormat
#define UxPutXrtFloatFldNegativeFormat(sw, val) \
	UxDDPutProp(sw, XmNxrtFldNegativeFormat, (XtArgVal)(val))
#endif

#ifndef UxGetXrtFloatFldPickList
#define UxGetXrtFloatFldPickList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtFldPickList)
#endif
#ifndef UxPutXrtFloatFldPickList
#define UxPutXrtFloatFldPickList(sw, val) \
	UxDDPutProp(sw, XmNxrtFldPickList, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtFloatField
#define UxCreateXrtFloatField(name, parent) \
	UxCreateSwidget(name, xmXrtFloatFieldWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTFOATFIELD_INCLUDED */

/***END*OF*FILE***************************************************************/
