/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtGaCircularDial.h	1.3    99/12/13 KL Group Inc.
 */

/******************************************************************************
				UxXrtGaCircularDial.h
******************************************************************************/

#ifndef UxXrtGaCircularDial_h
#define UxXrtGaCircularDial_h

#include <Xm/XrtGaCircularDial.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxPrim.h"
#include "UxXrtGaCircularDial.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XrtGaCDial_prpty_name(x)	XrtGaCircularDial_res_table[x].prpty, XrtGaCircularDial_res_table[x].name

#ifdef hp700v9
#define XrtGaDoubleToArgVal(d) UxXrtGaDoubleToArgVal(0,d)
#endif /* hp700v9 */

#ifndef UxGetXrtGaBorder
#define UxGetXrtGaBorder(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Border))
#endif
#ifndef UxPutXrtGaBorder
#define UxPutXrtGaBorder(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Border), val)
#endif

#ifndef UxGetXrtGaCircularScale
#define UxGetXrtGaCircularScale(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_CircularScale))
#endif
#ifndef UxPutXrtGaCircularScale
#define UxPutXrtGaCircularScale(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_CircularScale), val)
#endif

#ifndef UxGetXrtGaCounterList
#define UxGetXrtGaCounterList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_CounterList))
#endif
#ifndef UxPutXrtGaCounterList
#define UxPutXrtGaCounterList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_CounterList), val)
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Debug))
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Debug), val)
#endif

#ifndef UxGetXrtGaDoubleBuffer
#define UxGetXrtGaDoubleBuffer(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_DoubleBuffer))
#endif
#ifndef UxPutXrtGaDoubleBuffer
#define UxPutXrtGaDoubleBuffer(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_DoubleBuffer), val)
#endif

#ifndef UxGetXrtGaFrame
#define UxGetXrtGaFrame(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Frame))
#endif
#ifndef UxPutXrtGaFrame
#define UxPutXrtGaFrame(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Frame), val)
#endif

#ifndef UxGetXrtGaHighlightColor
#define UxGetXrtGaHighlightColor(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_HighlightColor))
#endif
#ifndef UxPutXrtGaHighlightColor
#define UxPutXrtGaHighlightColor(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_HighlightColor),val)
#endif

#ifndef UxGetXrtGaHighlightSelectedState
#define UxGetXrtGaHighlightSelectedState(sw) \
	UxGET_string(sw,XrtGaCDial_prpty_name(XrtGaCDial_HighlightSelectedState))
#endif
#ifndef UxPutXrtGaHighlightSelectedState
#define UxPutXrtGaHighlightSelectedState(sw, val) \
	UxPUT_string(sw,XrtGaCDial_prpty_name(XrtGaCDial_HighlightSelectedState), val)
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Image))
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Image), val)
#endif

#ifndef UxGetXrtGaImageLayout
#define UxGetXrtGaImageLayout(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_ImageLayout))
#endif
#ifndef UxPutXrtGaImageLayout
#define UxPutXrtGaImageLayout(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_ImageLayout),val)
#endif

#ifndef UxGetXrtGaLineInnerRadius
#define UxGetXrtGaLineInnerRadius(sw) \
	UxGET_float(sw, XrtGaCDial_prpty_name(XrtGaCDial_LineInnerRadius))
#endif
#ifndef UxPutXrtGaLineInnerRadius
#define UxPutXrtGaLineInnerRadius(sw, val) \
	UxPUT_float(sw, XrtGaCDial_prpty_name(XrtGaCDial_LineInnerRadius),val)
#endif

#ifndef UxGetXrtGaLineOuterRadius
#define UxGetXrtGaLineOuterRadius(sw) \
	UxGET_float(sw, XrtGaCDial_prpty_name(XrtGaCDial_LineOuterRadius))
#endif
#ifndef UxPutXrtGaLineOuterRadius
#define UxPutXrtGaLineOuterRadius(sw, val) \
	UxPUT_float(sw, XrtGaCDial_prpty_name(XrtGaCDial_LineOuterRadius),val)
#endif

#ifndef UxGetXrtGaMarker
#define UxGetXrtGaMarker(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Marker))
#endif
#ifndef UxPutXrtGaMarker
#define UxPutXrtGaMarker(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Marker), val)
#endif

#ifndef UxGetXrtGaOffsetDistance
#define UxGetXrtGaOffsetDistance(sw) \
	UxGET_float(sw, XrtGaCDial_prpty_name(XrtGaCDial_OffsetDistance))
#endif
#ifndef UxPutXrtGaOffsetDistance
#define UxPutXrtGaOffsetDistance(sw, val) \
	UxPUT_float(sw, XrtGaCDial_prpty_name(XrtGaCDial_OffsetDistance),val)
#endif

#ifndef UxGetXrtGaOffsetType
#define UxGetXrtGaOffsetType(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_OffsetType))
#endif
#ifndef UxPutXrtGaOffsetType
#define UxPutXrtGaOffsetType(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_OffsetType),val)
#endif

#ifndef UxGetXrtGaRangeList
#define UxGetXrtGaRangeList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_RangeList))
#endif
#ifndef UxPutXrtGaRangeList
#define UxPutXrtGaRangeList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_RangeList), val)
#endif

#ifndef UxGetXrtGaRenderList
#define UxGetXrtGaRenderList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_RenderList))
#endif
#ifndef UxPutXrtGaRenderList
#define UxPutXrtGaRenderList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_RenderList),val)
#endif

#ifndef UxGetXrtGaRepaint
#define UxGetXrtGaRepaint(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Repaint))
#endif
#ifndef UxPutXrtGaRepaint
#define UxPutXrtGaRepaint(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Repaint), val)
#endif

#ifndef UxGetXrtGaStateList
#define UxGetXrtGaStateList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_StateList))
#endif
#ifndef UxPutXrtGaStateList
#define UxPutXrtGaStateList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_StateList), val)
#endif

#ifndef UxGetXrtGaSwitch
#define UxGetXrtGaSwitch(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Switch))
#endif
#ifndef UxPutXrtGaSwitch
#define UxPutXrtGaSwitch(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_Switch), val)
#endif

#ifndef UxGetXrtGaTextList
#define UxGetXrtGaTextList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_TextList))
#endif
#ifndef UxPutXrtGaTextList
#define UxPutXrtGaTextList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_TextList), val)
#endif

#ifndef UxGetXrtGaTickList
#define UxGetXrtGaTickList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_TickList))
#endif
#ifndef UxPutXrtGaTickList
#define UxPutXrtGaTickList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_TickList), val)
#endif

#ifndef UxGetXrtGaUseRenderList
#define UxGetXrtGaUseRenderList(sw) \
	UxGET_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_UseRenderList))
#endif
#ifndef UxPutXrtGaUseRenderList
#define UxPutXrtGaUseRenderList(sw, val) \
	UxPUT_string(sw, XrtGaCDial_prpty_name(XrtGaCDial_UseRenderList),val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtGaCircularDial;

/* Design-time create macro */
#ifndef UxCreateXrtGaCircularDial
#define UxCreateXrtGaCircularDial(name, parent) \
	UxCreateSwidget(UxC_XrtGaCircularDial, name, parent)
#endif

#else /* RUN-TIME */

extern int	XrtGaGetDoubleProp();
extern double	XrtGaArgValToDouble();

#define RT_GA_GET_DOUBLE(sw,res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(sw,res))

#define RT_GA_PUT_DOUBLE(sw,res,val) \
	UxPutProp(sw,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

#ifndef UxGetXrtGaBorder
#define UxGetXrtGaBorder(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaBorder)
#endif
#ifndef UxPutXrtGaBorder
#define UxPutXrtGaBorder(sw, val) \
	UxDDPutProp(sw, XmNxrtGaBorder, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaCircularScale
#define UxGetXrtGaCircularScale(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaCircularScale)
#endif
#ifndef UxPutXrtGaCircularScale
#define UxPutXrtGaCircularScale(sw, val) \
	UxDDPutProp(sw, XmNxrtGaCircularScale, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaCounterList
#define UxGetXrtGaCounterList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaCounterList)
#endif
#ifndef UxPutXrtGaCounterList
#define UxPutXrtGaCounterList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaCounterList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDebug)
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDebug, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDoubleBuffer
#define UxGetXrtGaDoubleBuffer(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDoubleBuffer)
#endif
#ifndef UxPutXrtGaDoubleBuffer
#define UxPutXrtGaDoubleBuffer(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDoubleBuffer, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaFrame
#define UxGetXrtGaFrame(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaFrame)
#endif
#ifndef UxPutXrtGaFrame
#define UxPutXrtGaFrame(sw, val) \
	UxDDPutProp(sw, XmNxrtGaFrame, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaHighlightColor
#define UxGetXrtGaHighlightColor(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaHighlightColor)
#endif
#ifndef UxPutXrtGaHighlightColor
#define UxPutXrtGaHighlightColor(sw, val) \
	UxDDPutProp(sw, XmNxrtGaHighlightColor, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaHighlightSelectedState
#define UxGetXrtGaHighlightSelectedState(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaHighlightSelectedState)
#endif
#ifndef UxPutXrtGaHighlightSelectedState
#define UxPutXrtGaHighlightSelectedState(sw, val) \
	UxDDPutProp(sw, XmNxrtGaHighlightSelectedState, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImage)
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImageLayout
#define UxGetXrtGaImageLayout(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImageLayout)
#endif
#ifndef UxPutXrtGaImageLayout
#define UxPutXrtGaImageLayout(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImageLayout, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaLineInnerRadius
#define UxGetXrtGaLineInnerRadius(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaLineInnerRadius)
#endif
#ifndef UxPutXrtGaLineInnerRadius
#define UxPutXrtGaLineInnerRadius(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaLineInnerRadius, (val))
#endif

#ifndef UxGetXrtGaLineOuterRadius
#define UxGetXrtGaLineOuterRadius(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaLineOuterRadius)
#endif
#ifndef UxPutXrtGaLineOuterRadius
#define UxPutXrtGaLineOuterRadius(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaLineOuterRadius, (val))
#endif

#ifndef UxGetXrtGaMarker
#define UxGetXrtGaMarker(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaMarker)
#endif
#ifndef UxPutXrtGaMarker
#define UxPutXrtGaMarker(sw, val) \
	UxDDPutProp(sw, XmNxrtGaMarker, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaOffsetDistance
#define UxGetXrtGaOffsetDistance(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaOffsetDistance)
#endif
#ifndef UxPutXrtGaOffsetDistance
#define UxPutXrtGaOffsetDistance(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaOffsetDistance, (val))
#endif

#ifndef UxGetXrtGaOffsetType
#define UxGetXrtGaOffsetType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaOffsetType)
#endif
#ifndef UxPutXrtGaOffsetType
#define UxPutXrtGaOffsetType(sw, val) \
	UxDDPutProp(sw, XmNxrtGaOffsetType, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaRangeList
#define UxGetXrtGaRangeList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaRangeList)
#endif
#ifndef UxPutXrtGaRangeList
#define UxPutXrtGaRangeList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaRangeList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaRenderList
#define UxGetXrtGaRenderList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaRenderList)
#endif
#ifndef UxPutXrtGaRenderList
#define UxPutXrtGaRenderList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaRenderList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaRepaint
#define UxGetXrtGaRepaint(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaRepaint)
#endif
#ifndef UxPutXrtGaRepaint
#define UxPutXrtGaRepaint(sw, val) \
	UxDDPutProp(sw, XmNxrtGaRepaint, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaStateList
#define UxGetXrtGaStateList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaStateList)
#endif
#ifndef UxPutXrtGaStateList
#define UxPutXrtGaStateList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaStateList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaSwitch
#define UxGetXrtGaSwitch(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaSwitch)
#endif
#ifndef UxPutXrtGaSwitch
#define UxPutXrtGaSwitch(sw, val) \
	UxDDPutProp(sw, XmNxrtGaSwitch, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaTextList
#define UxGetXrtGaTextList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaTextList)
#endif
#ifndef UxPutXrtGaTextList
#define UxPutXrtGaTextList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaTextList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaTickList
#define UxGetXrtGaTickList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaTickList)
#endif
#ifndef UxPutXrtGaTickList
#define UxPutXrtGaTickList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaTickList, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaUseRenderList
#define UxGetXrtGaUseRenderList(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaUseRenderList)
#endif
#ifndef UxPutXrtGaUseRenderList
#define UxPutXrtGaUseRenderList(sw, val) \
	UxDDPutProp(sw, XmNxrtGaUseRenderList, ((XtArgVal)(val)))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGaCircularDial
#define UxCreateXrtGaCircularDial(name, parent) \
	UxCreateSwidget(name, xmXrtGaCircularDialWidgetClass, parent)
#endif


#endif /* DESIGN_TIME */

#endif
