/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gauge widget UIM/X integration file
 *
 * $AstecId: UxXrtGaState.hxx,v 1.3 2003/02/14 02:24:57 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtGaState.hxx	1.3    00/01/05 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtGaState : public UxGadget
{
    public:

	// Constructors
	UXINLINE UxXrtGaState(void);
	UXINLINE UxXrtGaState(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget(const char*, swidget);

	// Resource accessor functions

	UXINLINE char * GetFontList () const;
	UXINLINE void SetFontList (const char *);

	UXINLINE char * GetForeground () const;
	UXINLINE void SetForeground (const char *);

	UXINLINE char * GetXrtGaAlignment () const;
	UXINLINE void SetXrtGaAlignment (const char *);

	UXINLINE char * GetXrtGaAlignmentUseDefault () const;
	UXINLINE void SetXrtGaAlignmentUseDefault (const char *);

	UXINLINE double GetXrtGaAngle () const;
	UXINLINE void SetXrtGaAngle (double);

	UXINLINE char * GetXrtGaAngleUseDefault () const;
	UXINLINE void SetXrtGaAngleUseDefault (const char *);

	UXINLINE char * GetXrtGaCircularScale () const;
	UXINLINE void SetXrtGaCircularScale (const char *);

	UXINLINE char * GetXrtGaDebug () const;
	UXINLINE void SetXrtGaDebug (const char *);

	UXINLINE char * GetXrtGaIsShowing () const;
	UXINLINE void SetXrtGaIsShowing (const char *);

	UXINLINE char * GetXrtGaLineDisplay () const;
	UXINLINE void SetXrtGaLineDisplay (const char *);

	UXINLINE double GetXrtGaLineInnerRadius () const;
	UXINLINE void SetXrtGaLineInnerRadius (double);

	UXINLINE char * GetXrtGaLineInnerRadiusUseDefault () const;
	UXINLINE void SetXrtGaLineInnerRadiusUseDefault (const char *);

	UXINLINE double GetXrtGaLineOuterRadius () const;
	UXINLINE void SetXrtGaLineOuterRadius (double);

	UXINLINE char * GetXrtGaLineOuterRadiusUseDefault () const;
	UXINLINE void SetXrtGaLineOuterRadiusUseDefault (const char *);

	UXINLINE char * GetXrtGaLinePattern () const;
	UXINLINE void SetXrtGaLinePattern (const char *);

	UXINLINE int GetXrtGaLineThickness () const;
	UXINLINE void SetXrtGaLineThickness (int);

	UXINLINE char * GetXrtGaOffsetUseDefault () const;
	UXINLINE void SetXrtGaOffsetUseDefault (const char *);

	UXINLINE int GetXrtGaOffsetX () const;
	UXINLINE void SetXrtGaOffsetX (int);

	UXINLINE int GetXrtGaOffsetY () const;
	UXINLINE void SetXrtGaOffsetY (int);

	UXINLINE char * GetXrtGaText () const;
	UXINLINE void SetXrtGaText (const char *);


};

#ifdef DESIGN_TIME

#define XrtGaState_prpty_name(x)	XrtGaState_res_table[x].prpty, XrtGaState_res_table[x].name

extern Class_t UxC_XrtGaState;

#else /* (not DESIGN_TIME) */

#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// define macro to access properties of type double

extern "C" {
	XtArgVal UxGetXrtGaDoubleProp(swidget sw, char *res);
	double   XrtGaArgValToDouble(XtArgVal val);
	XtArgVal XrtGaDoubleToArgVal(double val);
}

#define RT_GA_GET_DOUBLE(res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(UxThis,res))
#define RT_GA_PUT_DOUBLE(res,val) \
	UxPutProp(UxThis,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

// Constructors
inline UxXrtGaState::UxXrtGaState(void){}
inline UxXrtGaState::UxXrtGaState(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget
UxXrtGaState::CreateSwidget (const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtGaStateWidgetClass, parent);
	return UxThis;
}

inline char *  UxXrtGaState::GetFontList (void) const
        { return (char * ) DDGetProp(XmNfontList);}
inline void UxXrtGaState::SetFontList (const char * val)
        { DDSetProp(XmNfontList, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetForeground (void) const
        { return (char * ) DDGetProp(XmNforeground);}
inline void UxXrtGaState::SetForeground (const char * val)
        { DDSetProp(XmNforeground, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaAlignment (void) const
        { return (char * ) DDGetProp(XmNxrtGaAlignment);}
inline void UxXrtGaState::SetXrtGaAlignment (const char * val)
        { DDSetProp(XmNxrtGaAlignment, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaAlignmentUseDefault (void) const
        { return (char * ) DDGetProp(XmNxrtGaAlignmentUseDefault);}
inline void UxXrtGaState::SetXrtGaAlignmentUseDefault (const char * val)
        { DDSetProp(XmNxrtGaAlignmentUseDefault, ((XtArgVal)(val)));}

inline double UxXrtGaState::GetXrtGaAngle (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaAngle);}
inline void UxXrtGaState::SetXrtGaAngle (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaAngle,val);}

inline char *  UxXrtGaState::GetXrtGaAngleUseDefault (void) const
        { return (char * ) DDGetProp(XmNxrtGaAngleUseDefault);}
inline void UxXrtGaState::SetXrtGaAngleUseDefault (const char * val)
        { DDSetProp(XmNxrtGaAngleUseDefault, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaCircularScale (void) const
        { return (char * ) DDGetProp(XmNxrtGaCircularScale);}
inline void UxXrtGaState::SetXrtGaCircularScale (const char * val)
        { DDSetProp(XmNxrtGaCircularScale, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaDebug (void) const
        { return (char * ) DDGetProp(XmNxrtGaDebug);}
inline void UxXrtGaState::SetXrtGaDebug (const char * val)
        { DDSetProp(XmNxrtGaDebug, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaIsShowing (void) const
        { return (char * ) DDGetProp(XmNxrtGaIsShowing);}
inline void UxXrtGaState::SetXrtGaIsShowing (const char * val)
        { DDSetProp(XmNxrtGaIsShowing, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaLineDisplay (void) const
        { return (char * ) DDGetProp(XmNxrtGaLineDisplay);}
inline void UxXrtGaState::SetXrtGaLineDisplay (const char * val)
        { DDSetProp(XmNxrtGaLineDisplay, ((XtArgVal)(val)));}

inline double UxXrtGaState::GetXrtGaLineInnerRadius (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaLineInnerRadius);}
inline void UxXrtGaState::SetXrtGaLineInnerRadius (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaLineInnerRadius,val);}

inline char *  UxXrtGaState::GetXrtGaLineInnerRadiusUseDefault (void) const
        { return (char * ) DDGetProp(XmNxrtGaLineInnerRadiusUseDefault);}
inline void UxXrtGaState::SetXrtGaLineInnerRadiusUseDefault (const char * val)
        { DDSetProp(XmNxrtGaLineInnerRadiusUseDefault, ((XtArgVal)(val)));}

inline double UxXrtGaState::GetXrtGaLineOuterRadius (void) const
	{ return RT_GA_GET_DOUBLE(XmNxrtGaLineOuterRadius);}
inline void UxXrtGaState::SetXrtGaLineOuterRadius (double val)
	{ RT_GA_PUT_DOUBLE(XmNxrtGaLineOuterRadius,val);}

inline char *  UxXrtGaState::GetXrtGaLineOuterRadiusUseDefault (void) const
        { return (char * ) DDGetProp(XmNxrtGaLineOuterRadiusUseDefault);}
inline void UxXrtGaState::SetXrtGaLineOuterRadiusUseDefault (const char * val)
        { DDSetProp(XmNxrtGaLineOuterRadiusUseDefault, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaLinePattern (void) const
        { return (char * ) DDGetProp(XmNxrtGaLinePattern);}
inline void UxXrtGaState::SetXrtGaLinePattern (const char * val)
        { DDSetProp(XmNxrtGaLinePattern, ((XtArgVal)(val)));}

inline int UxXrtGaState::GetXrtGaLineThickness (void) const
	{ return (int)IntGetProp(XmNxrtGaLineThickness);}
inline void UxXrtGaState::SetXrtGaLineThickness (int val)
	{ SetProp(XmNxrtGaLineThickness, ((XtArgVal)(val)));}

inline char *  UxXrtGaState::GetXrtGaOffsetUseDefault (void) const
        { return (char * ) DDGetProp(XmNxrtGaOffsetUseDefault);}
inline void UxXrtGaState::SetXrtGaOffsetUseDefault (const char * val)
        { DDSetProp(XmNxrtGaOffsetUseDefault, ((XtArgVal)(val)));}

inline int UxXrtGaState::GetXrtGaOffsetX (void) const
	{ return (int)IntGetProp(XmNxrtGaOffsetX);}
inline void UxXrtGaState::SetXrtGaOffsetX (int val)
	{ SetProp(XmNxrtGaOffsetX, ((XtArgVal)(val)));}

inline int UxXrtGaState::GetXrtGaOffsetY (void) const
	{ return (int)IntGetProp(XmNxrtGaOffsetY);}
inline void UxXrtGaState::SetXrtGaOffsetY (int val)
	{ SetProp(XmNxrtGaOffsetY, ((XtArgVal)(val)));}

inline char * UxXrtGaState::GetXrtGaText (void) const
	{ return (char * ) GetProp(XmNxrtGaText);}
inline void UxXrtGaState::SetXrtGaText (const char * val)
	{ SetProp(XmNxrtGaText, ((XtArgVal)(val)));}


#undef RT_GA_GET_DOUBLE
#undef RT_GA_PUT_DOUBLE

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */
