/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtGaSwitch.h	1.3    99/12/13 KL Group Inc.
 */

/******************************************************************************
				UxXrtGaSwitch.h
******************************************************************************/

#ifndef UxXrtGaSwitch_h
#define UxXrtGaSwitch_h

#include <Xm/XrtGaSwitch.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxGadget.h"
#include "UxXrtGaSwitch.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME
#ifndef NO_UX_MACROS

#define XrtGaSwitch_prpty_name(x)	XrtGaSwitch_res_table[x].prpty, XrtGaSwitch_res_table[x].name

#ifdef hp700v9
#define XrtGaDoubleToArgVal(d) UxXrtGaDoubleToArgVal(0,d)
#endif /* hp700v9 */

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_background))
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_background),val)
#endif

#ifndef UxGetXrtGaCircularScale
#define UxGetXrtGaCircularScale(sw) \
	UxGET_string(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_CircularScale))
#endif
#ifndef UxPutXrtGaCircularScale
#define UxPutXrtGaCircularScale(sw, val) \
	UxPUT_string(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_CircularScale), val)
#endif

#ifndef UxGetXrtGaContinuous
#define UxGetXrtGaContinuous(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Continuous))
#endif
#ifndef UxPutXrtGaContinuous
#define UxPutXrtGaContinuous(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Continuous), val)
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Debug))
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Debug), val)
#endif

#ifndef UxGetXrtGaDrawFunc
#define UxGetXrtGaDrawFunc(sw) \
	UxGET_voidFunction(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_DrawFunc))
#endif
#ifndef UxPutXrtGaDrawFunc
#define UxPutXrtGaDrawFunc(sw, val) \
	UxPUT_voidFunction(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_DrawFunc), val)
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Image))
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Image), val)
#endif

#ifndef UxGetXrtGaImageRotate
#define UxGetXrtGaImageRotate(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_ImageRotate))
#endif
#ifndef UxPutXrtGaImageRotate
#define UxPutXrtGaImageRotate(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_ImageRotate),val)
#endif

#ifndef UxGetXrtGaIncrementValue
#define UxGetXrtGaIncrementValue(sw) \
	UxGET_float(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_IncrementValue))
#endif
#ifndef UxPutXrtGaIncrementValue
#define UxPutXrtGaIncrementValue(sw, val) \
	UxPUT_float(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_IncrementValue), val)
#endif

#ifndef UxGetXrtGaInteractionType
#define UxGetXrtGaInteractionType(sw) \
	UxGET_string(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_InteractionType))
#endif
#ifndef UxPutXrtGaInteractionType
#define UxPutXrtGaInteractionType(sw, val) \
	UxPUT_string(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_InteractionType), val)
#endif

#ifndef UxGetXrtGaIsShowing
#define UxGetXrtGaIsShowing(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_IsShowing))
#endif
#ifndef UxPutXrtGaIsShowing
#define UxPutXrtGaIsShowing(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_IsShowing),val)
#endif

#ifndef UxGetXrtGaMultipleTurnEnabled
#define UxGetXrtGaMultipleTurnEnabled(sw) \
	UxGET_string(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_MultipleTurnEnabled))
#endif
#ifndef UxPutXrtGaMultipleTurnEnabled
#define UxPutXrtGaMultipleTurnEnabled(sw, val) \
	UxPUT_string(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_MultipleTurnEnabled), val)
#endif

#ifndef UxGetXrtGaMultipleTurnValue
#define UxGetXrtGaMultipleTurnValue(sw) \
	UxGET_float(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_MultipleTurnValue))
#endif
#ifndef UxPutXrtGaMultipleTurnValue
#define UxPutXrtGaMultipleTurnValue(sw, val) \
	UxPUT_float(sw,XrtGaSwitch_prpty_name(XrtGaSwitch_MultipleTurnValue), val)
#endif

#ifndef UxGetXrtGaRadius
#define UxGetXrtGaRadius(sw) \
	UxGET_float(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Radius))
#endif
#ifndef UxPutXrtGaRadius
#define UxPutXrtGaRadius(sw, val) \
	UxPUT_float(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Radius), val)
#endif

#ifndef UxGetXrtGaValue
#define UxGetXrtGaValue(sw) \
	UxGET_float(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Value))
#endif
#ifndef UxPutXrtGaValue
#define UxPutXrtGaValue(sw, val) \
	UxPUT_float(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_Value), val)
#endif

#ifndef UxGetXrtGaSwitchType
#define UxGetXrtGaSwitchType(sw) \
	UxGET_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_SwitchType))
#endif
#ifndef UxPutXrtGaSwitchType
#define UxPutXrtGaSwitchType(sw, val) \
	UxPUT_string(sw, XrtGaSwitch_prpty_name(XrtGaSwitch_SwitchType), val)
#endif


#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtGaSwitch;

/* Design-time create macro */
#ifndef UxCreateXrtGaSwitch
#define UxCreateXrtGaSwitch(name, parent) \
	UxCreateSwidget(UxC_XrtGaSwitch, name, parent)
#endif

#else /* RUN-TIME */

extern int	XrtGaGetDoubleProp();
extern double	XrtGaArgValToDouble();

#define RT_GA_GET_DOUBLE(sw,res) \
	XrtGaArgValToDouble(UxGetXrtGaDoubleProp(sw,res))

#define RT_GA_PUT_DOUBLE(sw,res,val) \
	UxPutProp(sw,res,(XtArgVal)XrtGaDoubleToArgVal((double)val))

#ifndef UxGetBackground
#define UxGetBackground(sw) \
	(char *) UxDDGetProp(sw, XmNbackground)
#endif
#ifndef UxPutBackground
#define UxPutBackground(sw, val) \
	UxDDPutProp(sw, XmNbackground, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaCircularScale
#define UxGetXrtGaCircularScale(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaCircularScale)
#endif
#ifndef UxPutXrtGaCircularScale
#define UxPutXrtGaCircularScale(sw, val) \
	UxDDPutProp(sw, XmNxrtGaCircularScale, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaContinuous
#define UxGetXrtGaContinuous(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaContinuous)
#endif
#ifndef UxPutXrtGaContinuous
#define UxPutXrtGaContinuous(sw, val) \
	UxDDPutProp(sw, XmNxrtGaContinuous, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDebug
#define UxGetXrtGaDebug(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaDebug)
#endif
#ifndef UxPutXrtGaDebug
#define UxPutXrtGaDebug(sw, val) \
	UxDDPutProp(sw, XmNxrtGaDebug, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaDrawFunc
#define UxGetXrtGaDrawFunc(sw) \
	(voidFunction) UxGetProp(sw, XmNxrtGaDrawFunc)
#endif
#ifndef UxPutXrtGaDrawFunc
#define UxPutXrtGaDrawFunc(sw, val) \
	UxPutProp(sw, XmNxrtGaDrawFunc, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImage
#define UxGetXrtGaImage(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImage)
#endif
#ifndef UxPutXrtGaImage
#define UxPutXrtGaImage(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImage, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaImageRotate
#define UxGetXrtGaImageRotate(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaImageRotate)
#endif
#ifndef UxPutXrtGaImageRotate
#define UxPutXrtGaImageRotate(sw, val) \
	UxDDPutProp(sw, XmNxrtGaImageRotate, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIncrementValue
#define UxGetXrtGaIncrementValue(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaIncrementValue)
#endif
#ifndef UxPutXrtGaIncrementValue
#define UxPutXrtGaIncrementValue(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaIncrementValue, (val))
#endif

#ifndef UxGetXrtGaInteractionType
#define UxGetXrtGaInteractionType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaInteractionType)
#endif
#ifndef UxPutXrtGaInteractionType
#define UxPutXrtGaInteractionType(sw, val) \
	UxDDPutProp(sw, XmNxrtGaInteractionType, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaIsShowing
#define UxGetXrtGaIsShowing(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaIsShowing)
#endif
#ifndef UxPutXrtGaIsShowing
#define UxPutXrtGaIsShowing(sw, val) \
	UxDDPutProp(sw, XmNxrtGaIsShowing, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaMultipleTurnEnabled
#define UxGetXrtGaMultipleTurnEnabled(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaMultipleTurnEnabled)
#endif
#ifndef UxPutXrtGaMultipleTurnEnabled
#define UxPutXrtGaMultipleTurnEnabled(sw, val) \
	UxDDPutProp(sw, XmNxrtGaMultipleTurnEnabled, ((XtArgVal)(val)))
#endif

#ifndef UxGetXrtGaMultipleTurnValue
#define UxGetXrtGaMultipleTurnValue(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaMultipleTurnValue)
#endif
#ifndef UxPutXrtGaMultipleTurnValue
#define UxPutXrtGaMultipleTurnValue(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaMultipleTurnValue, (val))
#endif

#ifndef UxGetXrtGaRadius
#define UxGetXrtGaRadius(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaRadius)
#endif
#ifndef UxPutXrtGaRadius
#define UxPutXrtGaRadius(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaRadius, (val))
#endif

#ifndef UxGetXrtGaValue
#define UxGetXrtGaValue(sw) \
	(double) RT_GA_GET_DOUBLE(sw, XmNxrtGaValue)
#endif
#ifndef UxPutXrtGaValue
#define UxPutXrtGaValue(sw, val) \
	RT_GA_PUT_DOUBLE(sw, XmNxrtGaValue, (val))
#endif

#ifndef UxGetXrtGaSwitchType
#define UxGetXrtGaSwitchType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGaSwitchType)
#endif
#ifndef UxPutXrtGaSwitchType
#define UxPutXrtGaSwitchType(sw, val) \
	UxDDPutProp(sw, XmNxrtGaSwitchType, ((XtArgVal)(val)))
#endif


/* Runtime create macro */
#ifndef UxCreateXrtGaSwitch
#define UxCreateXrtGaSwitch(name, parent) \
	UxCreateSwidget(name, xmXrtGaSwitchObjectClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif

