/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 * $AstecId: UxXrtGearCombo.hxx,v 1.8 2000/06/19 08:32:27 kosaka Exp $
 *
 *  SCCSID -- @(#)UxXrtGearCombo.hxx	1.7    99/01/29 KL Group Inc.
 */

#if defined(__cplusplus) && !defined(XT_CODE) && !defined(NO_UXBINDINGS)  && !defined(UIMX2_9)

class UxXrtGearCombo : public UxXrtManager
{
    public:

	// Constructors
	UXINLINE UxXrtGearCombo(void);
	UXINLINE UxXrtGearCombo(const char*, swidget);

	// Initialisation
	UXINLINE swidget CreateSwidget (const char*, swidget);

	// Resource accessor functions
	UXINLINE int  GetBlinkRate_Combo () const;
	UXINLINE void SetBlinkRate_Combo (int);

	UXINLINE short GetColumns_Combo () const;
	UXINLINE void SetColumns_Combo (short);

	UXINLINE long GetCursorPosition_Combo () const;
	UXINLINE void SetCursorPosition_Combo (long);

	UXINLINE char *  GetCursorPositionVisible_Combo () const;
	UXINLINE void SetCursorPositionVisible_Combo (const char *);

	UXINLINE char *  GetEditable_Combo () const;
	UXINLINE void SetEditable_Combo (const char *);

	UXINLINE char *  GetFontList_Combo () const;
	UXINLINE void SetFontList_Combo (const char *);

	UXINLINE int GetMaxLength_Combo () const;
	UXINLINE void SetMaxLength_Combo (int);

	UXINLINE short  GetMarginHeight_Combo () const;
	UXINLINE void SetMarginHeight_Combo (short);

	UXINLINE short  GetMarginWidth_Combo () const;
	UXINLINE void SetMarginWidth_Combo (short);

	UXINLINE char *  GetPendingDelete_Combo () const;
	UXINLINE void SetPendingDelete_Combo (const char *);

	UXINLINE char *  GetResizeWidth_Combo () const;
	UXINLINE void SetResizeWidth_Combo (const char *);

//	UXINLINE char *  GetSelectionArray_Combo () const;
//	UXINLINE void SetSelectionArray_Combo (const char *);

//	UXINLINE char *  GetSelectionArrayCount_Combo () const;
//	UXINLINE void SetSelectionArrayCount_Combo (const char *);

	UXINLINE int  GetSelectThreshold_Combo () const;
	UXINLINE void SetSelectThreshold_Combo (int);

	UXINLINE char *  GetValue_Combo () const;
	UXINLINE void SetValue_Combo (const char *);

//	UXINLINE char *  GetValueWcs_Combo () const;
//	UXINLINE void SetValueWcs_Combo (const char *);

	UXINLINE char *  GetVerifyBell_Combo () const;
	UXINLINE void SetVerifyBell_Combo (const char *);

	UXINLINE char *  GetXrtGearAlignment_Combo () const;
	UXINLINE void SetXrtGearAlignment_Combo (const char *);

	UXINLINE char * GetXrtGearArrowClass_Combo () const;
	UXINLINE void SetXrtGearArrowClass_Combo (const char *);

	UXINLINE char *  GetXrtGearArrowType_Combo () const;
	UXINLINE void SetXrtGearArrowType_Combo (const char *);

	UXINLINE char *  GetXrtGearPickList_Combo () const;
	UXINLINE void SetXrtGearPickList_Combo (const char *);

	UXINLINE int GetXrtGearPickListIndex_Combo () const;
	UXINLINE void SetXrtGearPickListIndex_Combo (int);

	UXINLINE char *  GetXrtGearSearchPolicy_Combo () const;
	UXINLINE void SetXrtGearSearchPolicy_Combo (const char *);

	UXINLINE short GetXrtGearSpacing_Combo () const;
	UXINLINE void SetXrtGearSpacing_Combo (short);

	UXINLINE int GetXrtGearVisibleItemCount_Combo () const;
	UXINLINE void SetXrtGearVisibleItemCount_Combo (int);

	UXINLINE char * GetXrtGearAutoComplete_Combo () const;
	UXINLINE void SetXrtGearAutoComplete_Combo(const char *);

};

#ifdef DESIGN_TIME

#define XRTGEAR_GEARCOMBO_TABLE(x)	xrtGearCombo_res_table[x].prpty, xrtGearCombo_res_table[x].name

extern Class_t UxC_XrtGearCombo;

#else /* (not DESIGN_TIME) */


#if defined(__alpha) && defined(__cplusplus)
#pragma message save
#pragma message disable narrowptr
#endif /* __alpha */

// Constructors
inline UxXrtGearCombo::UxXrtGearCombo(void){}
inline UxXrtGearCombo::UxXrtGearCombo(const char* name, swidget uXParent)
{
	CreateSwidget(name,uXParent);
}

// Initialisation
inline swidget UxXrtGearCombo::CreateSwidget(const char* name, swidget parent)
{
	if (UxThis == NULL)
		UxThis = UxCreateSwidget( (char *) name,
					  xmXrtGearComboWidgetClass, parent);
	return UxThis;
}

inline int  UxXrtGearCombo::GetBlinkRate_Combo (void) const
	{return (int)IntGetProp(XmNblinkRate); }
inline void UxXrtGearCombo::SetBlinkRate_Combo (int val)
	{ SetProp(XmNblinkRate, ((XtArgVal)(val)));}
				
inline short  UxXrtGearCombo::GetColumns_Combo (void) const
	{return ( short ) ShortGetProp(XmNcolumns);}
inline void UxXrtGearCombo::SetColumns_Combo (short val)
	{ DDSetProp(XmNcolumns, ((XtArgVal)(val)));}
				
inline long  UxXrtGearCombo::GetCursorPosition_Combo (void) const
	{return (long)GetProp(XmNcursorPosition);}
inline void UxXrtGearCombo::SetCursorPosition_Combo (long val)
	{ SetProp(XmNcursorPosition, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetCursorPositionVisible_Combo (void) const
	{return ( char * ) DDGetProp(XmNcursorPositionVisible);}
inline void UxXrtGearCombo::SetCursorPositionVisible_Combo (const char * val)
	{ DDSetProp(XmNcursorPositionVisible, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetEditable_Combo (void) const
	{return ( char * ) DDGetProp(XmNeditable);}
inline void UxXrtGearCombo::SetEditable_Combo (const char * val)
	{ DDSetProp(XmNeditable, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetFontList_Combo (void) const
	{return ( char * ) DDGetProp(XmNfontList);}
inline void UxXrtGearCombo::SetFontList_Combo (const char * val)
	{ DDSetProp(XmNfontList, ((XtArgVal)(val)));}
				
inline int  UxXrtGearCombo::GetMaxLength_Combo (void) const
	{return (int)IntGetProp(XmNmaxLength);}
inline void UxXrtGearCombo::SetMaxLength_Combo (int val)
	{ SetProp(XmNmaxLength, ((XtArgVal)(val)));}
				
inline short  UxXrtGearCombo::GetMarginHeight_Combo (void) const
	{return ( short ) ShortGetProp(XmNmarginHeight);}
inline void UxXrtGearCombo::SetMarginHeight_Combo (short val)
	{ DDSetProp(XmNmarginHeight, ((XtArgVal)(val)));}
				
inline short  UxXrtGearCombo::GetMarginWidth_Combo (void) const
	{return ( short ) ShortGetProp(XmNmarginWidth);}
inline void UxXrtGearCombo::SetMarginWidth_Combo (short val)
	{ DDSetProp(XmNmarginWidth, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetPendingDelete_Combo (void) const
	{return ( char * ) DDGetProp(XmNpendingDelete);}
inline void UxXrtGearCombo::SetPendingDelete_Combo (const char * val)
	{ DDSetProp(XmNpendingDelete, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetResizeWidth_Combo (void) const
	{return ( char * ) DDGetProp(XmNresizeWidth);}
inline void UxXrtGearCombo::SetResizeWidth_Combo (const char * val)
	{ DDSetProp(XmNresizeWidth, ((XtArgVal)(val)));}
				
//inline char *  UxXrtGearCombo::GetSelectionArray_Combo (void) const
//	{return ( char * ) DDGetProp(XmNselectionArray);}
//inline void UxXrtGearCombo::SetSelectionArray_Combo (const char * val)
//	{ DDSetProp(XmNselectionArray, ((XtArgVal)(val)));}
				
//inline char *  UxXrtGearCombo::GetSelectionArrayCount_Combo (void) const
//	{return ( char * ) DDGetProp(XmNselectionArrayCount);}
//inline void UxXrtGearCombo::SetSelectionArrayCount_Combo (const char * val)
//	{ DDSetProp(XmNselectionArrayCount, ((XtArgVal)(val)));}
				
inline int  UxXrtGearCombo::GetSelectThreshold_Combo (void) const
	{return (int)IntGetProp(XmNselectThreshold);}
inline void UxXrtGearCombo::SetSelectThreshold_Combo (int val)
	{ SetProp(XmNselectThreshold, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetValue_Combo (void) const
	{return ( char * ) DDGetProp(XmNvalue);}
inline void UxXrtGearCombo::SetValue_Combo (const char * val)
	{ DDSetProp(XmNvalue, ((XtArgVal)(val)));}
				
//inline char *  UxXrtGearCombo::GetValueWcs_Combo (void) const
//	{return ( char * ) DDGetProp(XmNvalueWcs);}
//inline void UxXrtGearCombo::SetValueWcs_Combo (const char * val)
//	{ DDSetProp(XmNvalueWcs, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetVerifyBell_Combo (void) const
	{return ( char * ) DDGetProp(XmNverifyBell);}
inline void UxXrtGearCombo::SetVerifyBell_Combo (const char * val)
	{ DDSetProp(XmNverifyBell, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetXrtGearAlignment_Combo (void) const
	{return ( char * ) DDGetProp(XmNxrtGearAlignment);}
inline void UxXrtGearCombo::SetXrtGearAlignment_Combo (const char * val)
	{ DDSetProp(XmNxrtGearAlignment, ((XtArgVal)(val)));}
				
inline char * UxXrtGearCombo::GetXrtGearArrowClass_Combo (void) const
	{ return (char * ) DDGetProp(XmNxrtGearArrowClass);}
inline void UxXrtGearCombo::SetXrtGearArrowClass_Combo (const char * val)
	{ DDSetProp(XmNxrtGearArrowClass, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetXrtGearArrowType_Combo (void) const
	{return ( char * ) DDGetProp(XmNxrtGearArrowType);}
inline void UxXrtGearCombo::SetXrtGearArrowType_Combo (const char * val)
	{ DDSetProp(XmNxrtGearArrowType, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetXrtGearPickList_Combo (void) const
	{return ( char * ) DDGetProp(XmNxrtGearPickList);}
inline void UxXrtGearCombo::SetXrtGearPickList_Combo (const char * val)
	{ DDSetProp(XmNxrtGearPickList, ((XtArgVal)(val)));}
				
inline int UxXrtGearCombo::GetXrtGearPickListIndex_Combo (void) const
	{return (int)IntGetProp(XmNxrtGearPickListIndex);}
inline void UxXrtGearCombo::SetXrtGearPickListIndex_Combo (int val)
	{ SetProp(XmNxrtGearPickListIndex, ((XtArgVal)(val)));}
				
inline char *  UxXrtGearCombo::GetXrtGearSearchPolicy_Combo (void) const
	{return ( char * ) DDGetProp(XmNxrtGearSearchPolicy);}
inline void UxXrtGearCombo::SetXrtGearSearchPolicy_Combo (const char * val)
	{ DDSetProp(XmNxrtGearSearchPolicy, ((XtArgVal)(val)));}
				
inline short UxXrtGearCombo::GetXrtGearSpacing_Combo (void) const
	{return ( short) ShortGetProp(XmNxrtGearSpacing);}
inline void UxXrtGearCombo::SetXrtGearSpacing_Combo (short val)
	{ SetProp(XmNxrtGearSpacing, ((XtArgVal)(val)));}

inline int UxXrtGearCombo::GetXrtGearVisibleItemCount_Combo (void) const
	{return (int)IntGetProp(XmNxrtGearVisibleItemCount);}
inline void UxXrtGearCombo::SetXrtGearVisibleItemCount_Combo (int val)
	{ SetProp(XmNxrtGearVisibleItemCount, ((XtArgVal)(val)));}

inline char * UxXrtGearCombo::GetXrtGearAutoComplete_Combo (void) const
	{ return (char *) DDGetProp(XmNxrtGearAutoComplete);}
inline void UxXrtGearCombo::SetXrtGearAutoComplete_Combo(const char * val)
	{ DDSetProp(XmNxrtGearAutoComplete, ((XtArgVal)(val)));}

#if defined(__alpha) && defined(__cplusplus)
#pragma message restore
#endif /* __alpha */

#endif /* DESIGN_TIME */
#endif /* __cplusplus */
