/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/graph widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtLabel.h	1.7    97/02/10 KL Group Inc.
 */

/******************************************************************************
				UxXrtLabel.h
******************************************************************************/

#ifndef UXXRTLABEL_INCLUDED
#define UXXRTLABEL_INCLUDED

#include <Xm/XrtLabel.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxPrim.h"
#include "UxXrtLabel.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME

#define XRTLBL_TABLE(x)	xrtlbl_res_table[x].prpty, xrtlbl_res_table[x].name

/* Design-Time UxGet and UxPut macros for xrtLblAlignment */
#ifndef UxGetAlignment
#define UxGetAlignment(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumAlignment))
#endif
#ifndef UxPutAlignment
#define UxPutAlignment(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumAlignment), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblFontList */
#ifndef UxGetFontList
#define UxGetFontList(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumFontList))
#endif
#ifndef UxPutFontList
#define UxPutFontList(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumFontList), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblLabelPixmap */
#ifndef UxGetLabelPixmap
#define UxGetLabelPixmap(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumLabelPixmap))
#endif
#ifndef UxPutLabelPixmap
#define UxPutLabelPixmap(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumLabelPixmap), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblLabelString */
#ifndef UxGetLabelString
#define UxGetLabelString(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumLabelString))
#endif
#ifndef UxPutLabelString
#define UxPutLabelString(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumLabelString), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblLabelType */
#ifndef UxGetLabelType
#define UxGetLabelType(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumLabelType))
#endif
#ifndef UxPutLabelType
#define UxPutLabelType(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumLabelType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblMarginHeight */
#ifndef UxGetMarginHeight
#define UxGetMarginHeight(sw) \
	UxGET_short(sw, XRTLBL_TABLE(xrtLblResNumMarginHeight))
#endif
#ifndef UxPutMarginHeight
#define UxPutMarginHeight(sw, val) \
	UxPUT_short(sw, XRTLBL_TABLE(xrtLblResNumMarginHeight), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblMarginWidt */
#ifndef UxGetMarginWidth
#define UxGetMarginWidth(sw) \
	UxGET_short(sw, XRTLBL_TABLE(xrtLblResNumMarginWidth))
#endif
#ifndef UxPutMarginWidth
#define UxPutMarginWidth(sw, val) \
	UxPUT_short(sw, XRTLBL_TABLE(xrtLblResNumMarginWidth), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblRecomputeSize */
#ifndef UxGetRecomputeSize
#define UxGetRecomputeSize(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumRecomputeSize))
#endif
#ifndef UxPutRecomputeSize
#define UxPutRecomputeSize(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumRecomputeSize), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblShadowThickness */
#ifndef UxGetShadowThickness
#define UxGetShadowThickness(sw) \
	UxGET_short(sw, XRTLBL_TABLE(xrtLblResNumShadowThickness))
#endif
#ifndef UxPutShadowThickness
#define UxPutShadowThickness(sw, val) \
	UxPUT_short(sw, XRTLBL_TABLE(xrtLblResNumShadowThickness), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblStringDirection */
#ifndef UxGetStringDirection
#define UxGetStringDirection(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumStringDirection))
#endif
#ifndef UxPutStringDirection
#define UxPutStringDirection(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumStringDirection), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblXrtLblBackgroundString */
#ifndef UxGetXrtLblBackgroundString
#define UxGetXrtLblBackgroundString(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumBackgroundString))
#endif
#ifndef UxPutXrtLblBackgroundString
#define UxPutXrtLblBackgroundString(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumBackgroundString), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblXrtLblBorderType */
#ifndef UxGetXrtLblBorderType
#define UxGetXrtLblBorderType(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumBorderType))
#endif
#ifndef UxPutXrtLblBorderType
#define UxPutXrtLblBorderType(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumBorderType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblXrtLblForegroundString */
#ifndef UxGetXrtLblForegroundString
#define UxGetXrtLblForegroundString(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumForegroundString))
#endif
#ifndef UxPutXrtLblForegroundString
#define UxPutXrtLblForegroundString(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumForegroundString), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtLblXrtLblRotation */
#ifndef UxGetXrtLblRotation
#define UxGetXrtLblRotation(sw) \
	UxGET_string(sw, XRTLBL_TABLE(xrtLblResNumRotation))
#endif
#ifndef UxPutXrtLblRotation
#define UxPutXrtLblRotation(sw, val) \
	UxPUT_string(sw, XRTLBL_TABLE(xrtLblResNumRotation), val)
#endif

extern Class_t	UxC_XrtLabel;
/* Design-time create macro */
#ifndef UxCreateXrtLabel
#define UxCreateXrtLabel(name, parent) \
	UxCreateSwidget(UxC_XrtLabel, name, parent)
#endif

#else /* Not DESIGN_TIME */

#ifndef UxGetAlignment
#define UxGetAlignment(sw) \
	(char *) UxDDGetProp(sw, XmNalignment)
#endif
#ifndef UxPutAlignment
#define UxPutAlignment(sw, val) \
	UxDDPutProp(sw, XmNalignment, (XtArgVal)(val))
#endif

#ifndef UxGetFontList
#define UxGetFontList(sw) \
	(char *) UxDDGetProp(sw, XmNfontList)
#endif
#ifndef UxPutFontList
#define UxPutFontList(sw, val) \
	UxDDPutProp(sw, XmNfontList, (XtArgVal)(val))
#endif

#ifndef UxGetLabelPixmap
#define UxGetLabelPixmap(sw) \
	(char *) UxDDGetProp(sw, XmNlabelPixmap)
#endif
#ifndef UxPutLabelPixmap
#define UxPutLabelPixmap(sw, val) \
	UxDDPutProp(sw, XmNlabelPixmap, (XtArgVal)(val))
#endif

#ifndef UxGetLabelString
#define UxGetLabelString(sw) \
	(char *) UxGetProp(sw, XmNlabelString)
#endif
#ifndef UxPutLabelString
#define UxPutLabelString(sw, val) \
	UxPutProp(sw, XmNlabelString, (XtArgVal)(val))
#endif

#ifndef UxGetLabelType
#define UxGetLabelType(sw) \
	(char *) UxDDGetProp(sw, XmNlabelType)
#endif
#ifndef UxPutLabelType
#define UxPutLabelType(sw, val) \
	UxDDPutProp(sw, XmNlabelType, (XtArgVal)(val))
#endif

#ifndef UxGetMarginHeight
#define UxGetMarginHeight(sw) \
	(short)UxShortGetProp(sw, XmNmarginHeight)
#endif
#ifndef UxPutMarginHeight
#define UxPutMarginHeight(sw, val) \
	UxPutProp(sw, XmNmarginHeight, (XtArgVal)(val))
#endif

#ifndef UxGetMarginWidth
#define UxGetMarginWidth(sw) \
	(short)UxShortGetProp(sw, XmNmarginWidth)
#endif
#ifndef UxPutMarginWidth
#define UxPutMarginWidth(sw, val) \
	UxPutProp(sw, XmNmarginWidth, (XtArgVal)(val))
#endif

#ifndef UxGetRecomputeSize
#define UxGetRecomputeSize(sw) \
	(char *) UxDDGetProp(sw, XmNrecomputeSize)
#endif
#ifndef UxPutRecomputeSize
#define UxPutRecomputeSize(sw, val) \
	UxDDPutProp(sw, XmNrecomputeSize, (XtArgVal)(val))
#endif


#ifndef UxGetShadowThickness
#define UxGetShadowThickness(sw) \
	(short)UxShortGetProp(sw, XmNshadowThickness)
#endif
#ifndef UxPutShadowThickness
#define UxPutShadowThickness(sw, val) \
	UxPutProp(sw, XmNshadowThickness, (XtArgVal)(val))
#endif

#ifndef UxGetStringDirection
#define UxGetStringDirection(sw) \
	(char *) UxDDGetProp(sw, XmNstringDirection)
#endif
#ifndef UxPutStringDirection
#define UxPutStringDirection(sw, val) \
	UxDDPutProp(sw, XmNstringDirection, (XtArgVal)(val))
#endif

#ifndef UxGetXrtLblBackgroundString
#define UxGetXrtLblBackgroundString(sw) \
	(char *) UxGetProp(sw, XmNxrtLblBackgroundString)
#endif
#ifndef UxPutXrtLblBackgroundString
#define UxPutXrtLblBackgroundString(sw, val) \
	UxPutProp(sw, XmNxrtLblBackgroundString, (XtArgVal)(val))
#endif

#ifndef UxGetXrtLblBorderType
#define UxGetXrtLblBorderType(sw) \
	(char *) UxDDGetProp(sw, XmNxrtLblBorderType)
#endif
#ifndef UxPutXrtLblBorderType
#define UxPutXrtLblBorderType(sw, val) \
	UxDDPutProp(sw, XmNxrtLblBorderType, (XtArgVal)(val))
#endif

#ifndef UxGetXrtLblForegroundString
#define UxGetXrtLblForegroundString(sw) \
	(char *) UxGetProp(sw, XmNxrtLblForegroundString)
#endif
#ifndef UxPutXrtLblForegroundString
#define UxPutXrtLblForegroundString(sw, val) \
	UxPutProp(sw, XmNxrtLblForegroundString, (XtArgVal)(val))
#endif

#ifndef UxGetXrtLblRotation
#define UxGetXrtLblRotation(sw) \
	(char *) UxDDGetProp(sw, XmNxrtLblRotation)
#endif
#ifndef UxPutXrtLblRotation
#define UxPutXrtLblRotation(sw, val) \
	UxDDPutProp(sw, XmNxrtLblRotation, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtLabel
#define UxCreateXrtLabel(name, parent) \
	UxCreateSwidget(name, xtXrtLabelWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UxXRTLABEL_INCLUDED */

/***END*OF*FILE****************************************************************/
