/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 *  SCCSID -- @(#)UxXrtTabB.h	1.5    97/02/10 KL Group Inc.
 */

/******************************************************************************
				UxXrtTabB.h
******************************************************************************/

#ifndef UXXRTTABB_INCLUDED
#define UXXRTTABB_INCLUDED

#include <Xm/XrtTabB.h>	/* Widget class public header file */
#include "Xrt_restable.h"
#include "UxPushB.h"
#include "UxXrtTabB.hxx"  /* Include C++ header file (New in UIM/X 3.0)*/

#ifdef DESIGN_TIME

#ifndef NO_UX_MACROS

#define XRTGEAR_TABB_TABLE(x)	xrtTabB_res_table[x].prpty, xrtTabB_res_table[x].name

/* Design-Time UxGet and UxPut macros for xrtTabBAnchorSide */
#ifndef UxGetXrtGearAnchorSide_TabB
#define UxGetXrtGearAnchorSide_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumAnchorSide))
#endif
#ifndef UxPutXrtGearAnchorSide_TabB
#define UxPutXrtGearAnchorSide_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumAnchorSide), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBCornerSize */
#ifndef UxGetXrtGearCornerSize_TabB
#define UxGetXrtGearCornerSize_TabB(sw) \
	UxGET_short(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumCornerSize))
#endif
#ifndef UxPutXrtGearCornerSize_TabB
#define UxPutXrtGearCornerSize_TabB(sw, val) \
	UxPUT_short(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumCornerSize), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBLabelPixmap */
#ifndef UxGetXrtGearLabelPixmap_TabB
#define UxGetXrtGearLabelPixmap_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumLabelPixmap))
#endif
#ifndef UxPutXrtGearLabelPixmap_TabB
#define UxPutXrtGearLabelPixmap_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumLabelPixmap), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBLabelType */
#ifndef UxGetXrtGearLabelType_TabB
#define UxGetXrtGearLabelType_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumLabelType))
#endif
#ifndef UxPutXrtGearLabelType_TabB
#define UxPutXrtGearLabelType_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumLabelType), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBLayoutSpacing */
#ifndef UxGetXrtGearLayoutSpacing_TabB
#define UxGetXrtGearLayoutSpacing_TabB(sw) \
	UxGET_short(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumLayoutSpacing))
#endif
#ifndef UxPutXrtGearLayoutSpacing_TabB
#define UxPutXrtGearLayoutSpacing_TabB(sw, val) \
	UxPUT_short(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumLayoutSpacing), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBMask */
#ifndef UxGetXrtGearMask_TabB
#define UxGetXrtGearMask_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumMask))
#endif
#ifndef UxPutXrtGearMask_TabB
#define UxPutXrtGearMask_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumMask), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBPixmapRotation */
#ifndef UxGetXrtGearPixmapRotation_TabB
#define UxGetXrtGearPixmapRotation_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumPixmapRotation))
#endif
#ifndef UxPutXrtGearPixmapRotation_TabB
#define UxPutXrtGearPixmapRotation_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumPixmapRotation), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBStringLayout */
#ifndef UxGetXrtGearStringLayout_TabB
#define UxGetXrtGearStringLayout_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumStringLayout))
#endif
#ifndef UxPutXrtGearStringLayout_TabB
#define UxPutXrtGearStringLayout_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumStringLayout), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBStyle */
#ifndef UxGetXrtGearStyle_TabB
#define UxGetXrtGearStyle_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumStyle))
#endif
#ifndef UxPutXrtGearStyle_TabB
#define UxPutXrtGearStyle_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumStyle), val)
#endif

/* Design-Time UxGet and UxPut macros for xrtTabBStringRotation */
#ifndef UxGetXrtGearStringRotation_TabB
#define UxGetXrtGearStringRotation_TabB(sw) \
	UxGET_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumStringRotation))
#endif
#ifndef UxPutXrtGearStringRotation_TabB
#define UxPutXrtGearStringRotation_TabB(sw, val) \
	UxPUT_string(sw, XRTGEAR_TABB_TABLE(xrtTabBResNumStringRotation), val)
#endif

#endif /* NO_UX_MACROS */

extern Class_t	UxC_XrtTabB;
/* Design-time create macro */
#ifndef UxCreateXrtTabB
#define UxCreateXrtTabB(name, parent) \
	UxCreateSwidget(UxC_XrtTabB, name, parent)
#endif

#else /* RUN_TIME */

#ifndef UxGetXrtGearAnchorSide_TabB
#define UxGetXrtGearAnchorSide_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearAnchorSide)
#endif
#ifndef UxPutXrtGearAnchorSide_TabB
#define UxPutXrtGearAnchorSide_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearAnchorSide, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearCornerSize_TabB
#define UxGetXrtGearCornerSize_TabB(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearCornerSize)
#endif
#ifndef UxPutXrtGearCornerSize_TabB
#define UxPutXrtGearCornerSize_TabB(sw, val) \
	UxPutProp(sw, XmNxrtGearCornerSize, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearLabelPixmap_TabB
#define UxGetXrtGearLabelPixmap_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearLabelPixmap)
#endif
#ifndef UxPutXrtGearLabelPixmap_TabB
#define UxPutXrtGearLabelPixmap_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearLabelPixmap, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearLabelType_TabB
#define UxGetXrtGearLabelType_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearLabelType)
#endif
#ifndef UxPutXrtGearLabelType_TabB
#define UxPutXrtGearLabelType_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearLabelType, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearLayoutSpacing_TabB
#define UxGetXrtGearLayoutSpacing_TabB(sw) \
	(short)UxShortGetProp(sw, XmNxrtGearLayoutSpacing)
#endif
#ifndef UxPutXrtGearLayoutSpacing_TabB
#define UxPutXrtGearLayoutSpacing_TabB(sw, val) \
	UxPutProp(sw, XmNxrtGearLayoutSpacing, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearMask_TabB
#define UxGetXrtGearMask_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearMask)
#endif
#ifndef UxPutXrtGearMask_TabB
#define UxPutXrtGearMask_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearMask, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearPixmapRotation_TabB
#define UxGetXrtGearPixmapRotation_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearPixmapRotation)
#endif
#ifndef UxPutXrtGearPixmapRotation_TabB
#define UxPutXrtGearPixmapRotation_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearPixmapRotation, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearStringLayout_TabB
#define UxGetXrtGearStringLayout_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearStringLayout)
#endif
#ifndef UxPutXrtGearStringLayout_TabB
#define UxPutXrtGearStringLayout_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearStringLayout, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearStyle_TabB
#define UxGetXrtGearStyle_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearStyle)
#endif
#ifndef UxPutXrtGearStyle_TabB
#define UxPutXrtGearStyle_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearStyle, (XtArgVal)(val))
#endif

#ifndef UxGetXrtGearStringRotation_TabB
#define UxGetXrtGearStringRotation_TabB(sw) \
	(char *) UxDDGetProp(sw, XmNxrtGearStringRotation)
#endif
#ifndef UxPutXrtGearStringRotation_TabB
#define UxPutXrtGearStringRotation_TabB(sw, val) \
	UxDDPutProp(sw, XmNxrtGearStringRotation, (XtArgVal)(val))
#endif

/* Runtime create macro */
#ifndef UxCreateXrtTabB
#define UxCreateXrtTabB(name, parent) \
	UxCreateSwidget(name, xmXrtTabButtonWidgetClass, parent)
#endif

#endif /* DESIGN_TIME */

#endif /* UXXRTTABB_INCLUDED */

/***END*OF*FILE***************************************************************/
