/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/3d widget UIM/X integration file
 *
 * $AstecId: Xrt3d_xtype.h,v 1.2 1999/10/09 17:53:40 nakayama Exp $
 *
 *  SCCSID -- @(#)Xrt3d_xtype.h	1.8    98/11/05 KL Group Inc.
 */

/******************************************************************************
				Xrt3d_xtype.h
******************************************************************************/

#ifndef XRT3D_XTYPES_H
#define XRT3D_XTYPES_H

/* Xtypes that are initialized in Xrt3d_xtype.c */

extern int     UxXT_Xrt3dAdjust;
extern int     UxXT_Xrt3dAlign;
extern int     UxXT_Xrt3dAnchor;
extern int     UxXT_Xrt3dAnnoMethod;
extern int     UxXT_Xrt3dAttachMethod;
extern int     UxXT_Xrt3dBarFormat;
extern int     UxXT_Xrt3dBorder;
extern int     UxXT_Xrt3dContourStyles;
extern int     UxXT_Xrt3dDistnMethod;
extern int     UxXT_Xrt3dDistnTable;
extern int     UxXT_Xrt3dDouble;
extern int     UxXT_Xrt3dLegendStyle;
extern int     UxXT_Xrt3dPreviewMethod;
extern int     UxXT_Xrt3dPlane;
extern int     UxXT_Xrt3dProject;
extern int     UxXT_Xrt3dStrings;
extern int     UxXT_Xrt3dStrokeFont;
extern int     UxXT_Xrt3dSurfaceData;
extern int     UxXT_Xrt3dTextList;
extern int     UxXT_Xrt3dType;
extern int     UxXT_Xrt3dValueLabels;
extern int     UxXT_Xrt3dXYColors;
extern int     UxXT_Xrt3dXGridLines;
extern int     UxXT_Xrt3dYGridLines;
extern int     UxXT_Xrt3dZGridLines;
extern int     UxXT_Xrt3dZoneData;
extern int     UxXT_Xrt3dZoneMethod;

extern int     UxXT_Xrt3dDataStyles;
extern int     UxXT_Xrt3dDistnRange;
extern int     UxXT_Xrt3dImage;
extern int     UxXT_Xrt3dImageLayout;
extern int     UxXT_Xrt3dLineStyle;

/* Xrt3d Specific function pointers */

extern int      UxValuesOfXrt3dAdjust();
extern int      UxValuesOfXrt3dAlign();
extern int      UxValuesOfXrt3dAnchor();
extern int      UxValuesOfXrt3dAnnoMethod();
extern int      UxValuesOfXrt3dAttachMethod();
extern int      UxValuesOfXrt3dBarFormat();
extern int      UxValuesOfXrt3dBorder();
extern int      UxValuesOfXrt3dContourStyles();
extern int      UxValuesOfXrt3dData();
extern int      UxValuesOfXrt3dDistnMethod();
extern int		UxValuesOfXrt3dDistnTable();
extern int		UxValuesOfXrt3dDouble();
extern int      UxValuesOfXrt3dLegendStyle();
extern int      UxValuesOfXrt3dPreviewMethod();
extern int      UxValuesOfXrt3dPlane();
extern int      UxValuesOfXrt3dProject();
extern int      UxValuesOfXrt3dStrings();
extern int      UxValuesOfXrt3dStrokeFont();
extern int      UxValuesOfXrt3dTextList();
extern int      UxValuesOfXrt3dType();
extern int      UxValuesOfXrt3dValueLabels();
extern int      UxValuesOfXrt3dXYColors();
extern int      UxValuesOfXrt3dXGridLines();
extern int      UxValuesOfXrt3dYGridLines();
extern int      UxValuesOfXrt3dZGridLines();
extern int      UxValuesOfXrt3dZoneMethod();

extern int		UxValuesOfXrt3dDataStyles();
extern int	    UxValuesOfXrt3dDistnRange();
extern int 		UxValuesOfXrt3dImage();
extern int	    UxValuesOfXrt3dImageLayout();
extern int	    UxValuesOfXrt3dLineStyle();


extern int      UxValidateXrt3dAdjust();
extern int      UxValidateXrt3dAlign();
extern int      UxValidateXrt3dAnchor();
extern int      UxValidateXrt3dAnnoMethod();
extern int      UxValidateXrt3dAttachMethod();
extern int      UxValidateXrt3dBarFormat();
extern int      UxValidateXrt3dBorder();
extern int      UxValidateXrt3dData();
extern int      UxValidateXrt3dDistnMethod();
extern int		UxValidateXrt3dDistnTable();
extern int      UxValidateXrt3dLegendStyle();
extern int      UxValidateXrt3dPreviewMethod();
extern int      UxValidateXrt3dPlane();
extern int      UxValidateXrt3dProject();
extern int      UxValidateXrt3dStrokeFont();
extern int      UxValidateXrt3dType();
extern int      UxValidateXrt3dXGridLines();
extern int      UxValidateXrt3dYGridLines();
extern int      UxValidateXrt3dZGridLines();
extern int      UxValidateXrt3dZoneMethod();

extern int		UxValidateXrt3dDistnRange();
extern int	    UxValidateXrt3dDataStyles();
extern int 	    UxValidateXrt3dImage();
extern int 	    UxValidateXrt3dImageLayout();
extern int      UxValidateXrt3dLineStyle();

#endif /* XRT3D_XTYPES_H */
