/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/gear widget UIM/X integration file
 *
 * $AstecId: XrtGear_resnum.h,v 1.4 1999/10/13 11:51:30 nakayama Exp $
 *  SCCSID -- @(#)XrtGear.resnum.h	1.10    98/11/05 KL Group Inc.
 */

/******************************************************************************
				XrtGear.resnum.h
******************************************************************************/

#ifndef XRTGEAR_RESNUM_H 
#define XRTGEAR_RESNUM_H

typedef enum {
	xrtAlnrResNumAlignerAlignment,
	xrtAlnrResNumAlignBaseline,
	xrtAlnrResNumColumnSpacing,
	xrtAlnrResNumMarginHeight,
	xrtAlnrResNumMarginWidth,
	xrtAlnrResNumOrientation,
	xrtAlnrResNumPosition,
	xrtAlnrResNumResizeHeight,
	xrtAlnrResNumResizeWidth,
	xrtAlnrResNumRowSpacing,
	size_xrtAlnrResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtAlnrResNum*/
} XrtAlnrResNum;

typedef enum {
	xrtGLblResNumBorderType,
	xrtGLblResNumLabelPixmap,
	xrtGLblResNumLabelType,
	xrtGLblResNumLayoutSpacing,
	xrtGLblResNumMask,
	xrtGLblResNumPixmapRotation,
	xrtGLblResNumStringLayout,
	xrtGLblResNumStringRotation,
	size_xrtGLblResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtGLblResNum*/
} XrtGLblResNum;

typedef enum {
	xrtPBResNumArmMask,			
	xrtPBResNumArmPixmap,		
 	xrtPBResNumLabelPixmap,		
 	xrtPBResNumLabelType,
	xrtPBResNumLayoutSpacing,
	xrtPBResNumMask,
	xrtPBResNumPixmapRotation,
	xrtPBResNumStringLayout,
	xrtPBResNumStringRotation,

	xrtPBResNumActive,
	size_xrtPBResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtPBResNum*/
} XrtPBResNum;

typedef enum {
	xrtTabBResNumAnchorSide,
	xrtTabBResNumCornerSize,	
	xrtTabBResNumLabelPixmap,	
	xrtTabBResNumLabelType,
	xrtTabBResNumLayoutSpacing,
	xrtTabBResNumMask,			
	xrtTabBResNumPixmapRotation,
	xrtTabBResNumStringLayout,
	xrtTabBResNumStringRotation,
	xrtTabBResNumStyle,
	size_xrtTabBResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtTabBResNum*/
} XrtTabBResNum;

typedef enum {
	xrtTabMResNumActivePageNumber,
	xrtTabMResNumActivePageWidget,
	xrtTabMResNumActiveTabWidget,
	xrtTabMResNumArrowDisplayPolicy,
	xrtTabMResNumArrowHeight,
	xrtTabMResNumArrowWidth,
	xrtTabMResNumChildType,
	xrtTabMResNumCornerSize,
	xrtTabMResNumFirstVisibleTab,
	xrtTabMResNumHighlightThickness,
	xrtTabMResNumLastVisibleTab,
	xrtTabMResNumMarginHeight,	
	xrtTabMResNumMarginWidth,	
	xrtTabMResNumPageAttachPolicy,
	xrtTabMResNumPageCallback,
	xrtTabMResNumPageNumber,
	xrtTabMResNumPageWidget,
	xrtTabMResNumResizeCallback,
	xrtTabMResNumShadowThickness,
	xrtTabMResNumTabResize,
	xrtTabMResNumTabRotation,
	xrtTabMResNumTabSide,
	xrtTabMResNumTabSpacing,
	xrtTabMResNumTabStretch,
	xrtTabMResNumWidgetPosition,
	size_xrtTabMResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtTabMResNum*/
} XrtTabMResNum;

typedef enum {
	xrtTogBResNumIndicator,
	xrtTogBResNumIndicatorMaskList,
	xrtTogBResNumIndicatorPixmapList,
	xrtTogBResNumNumStates,
	xrtTogBResNumSelectColor,
	xrtTogBResNumState,
	xrtTogBResNumStateChangedCallback,
	xrtTogBResNumUnselectColor,
	size_xrtTogBResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtGearResNum*/
} XrtTogBResNum;

typedef enum {
	xrtTbarResNumBottomSpace,
	xrtTbarResNumLeftSpace,
	xrtTbarResNumMarginHeight,
	xrtTbarResNumMarginWidth,
	xrtTbarResNumOrientation,
	xrtTbarResNumPosition,
	xrtTbarResNumRightSpace,
	xrtTbarResNumTopSpace,
	size_xrtTbarResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtTbarResNum*/
} XrtTbarResNum;

typedef enum {
	xrtOutlinerResNumFontList,
	xrtOutlinerResNumHighlightThickness,
	xrtOutlinerResNumScrollBarPlacement, 
	xrtOutlinerResNumActivateCallback,
	xrtOutlinerResNumAutoSort,
	xrtOutlinerResNumBorderLocation,
	xrtOutlinerResNumBorderType,
	xrtOutlinerResNumColumnLabelsShow,
	xrtOutlinerResNumColumnMoveAllow,
	xrtOutlinerResNumColumnMoveCallback,
	xrtOutlinerResNumColumnSelected,
	xrtOutlinerResNumColumnSelectionCallback,
	xrtOutlinerResNumCursor,
	xrtOutlinerResNumCursorResizeWidth,
	xrtOutlinerResNumCursorTracking,
	xrtOutlinerResNumCursorTrackingCallback,
	xrtOutlinerResNumDoubleBuffer,
	xrtOutlinerResNumFolderStateCallback,
	xrtOutlinerResNumFolderStateMask,
	xrtOutlinerResNumHeightPreferredCount,
	xrtOutlinerResNumHeightResizePolicy,
	xrtOutlinerResNumHeightSizingPolicy,
	xrtOutlinerResNumHeightVirtual,
	xrtOutlinerResNumImportCallback,
	xrtOutlinerResNumMarginHeight,
	xrtOutlinerResNumMarginWidth,
	xrtOutlinerResNumNodeCompareProc,
	xrtOutlinerResNumNodeCreateCallback,
	xrtOutlinerResNumNodeCurrent,
	xrtOutlinerResNumNodeCurrentChangedCallback,
	xrtOutlinerResNumNodeHeight,
	xrtOutlinerResNumNodeImportPolicy,
	xrtOutlinerResNumNodeIndent,
	xrtOutlinerResNumNodeIndentPolicy,
	xrtOutlinerResNumNodeMoveCallback,
	xrtOutlinerResNumNodeMovePolicy,
	xrtOutlinerResNumNodeSpacing,
	xrtOutlinerResNumNodeStyleDefault,
	xrtOutlinerResNumNodeTop,
	xrtOutlinerResNumPSFontMapList,
	xrtOutlinerResNumRepaint,
	xrtOutlinerResNumPrintCallback,
	xrtOutlinerResNumResizeCallback,
	xrtOutlinerResNumScrollBarHoriz,
	xrtOutlinerResNumScrollBarHorizDisplayPolicy,
	xrtOutlinerResNumScrollBarVert,
	xrtOutlinerResNumScrollBarVertDisplayPolicy,
	xrtOutlinerResNumSelectionCallback,
	xrtOutlinerResNumSelectionPolicy,
	xrtOutlinerResNumSelectionRestrictions,
	xrtOutlinerResNumShadowThickness,
	xrtOutlinerResNumTextHorizClipPolicy,
	xrtOutlinerResNumTreeData,
	xrtOutlinerResNumWidthChar,
	xrtOutlinerResNumWidthPreferredCount,
	xrtOutlinerResNumWidthResizePolicy,
	xrtOutlinerResNumWidthSizingPolicy,
	xrtOutlinerResNumWidthVirtual,

	xrtOutlinerResNumEditable,
	xrtOutlinerResNumEditor,
	xrtOutlinerResNumEditNode,
	xrtOutlinerResNumEditColumn,
	xrtOutlinerResNumEditType,
	xrtOutlinerResNumHighlightOnDrag,
	xrtOutlinerResNumNodeCheckForDuplicates,
	xrtOutlinerResNumNodeEnterCellCallback,
	xrtOutlinerResNumNodeValidateCallback,
	xrtOutlinerResNumTextEditor,
	size_xrtOutlinerResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtOutlinerResNum*/
} XrtOutlinerResNum;

typedef enum {
	xrtNodeStyleResNumFontList,
	xrtNodeStyleResNumForeground,
	xrtNodeStyleResNumBackgroundSelected,
	xrtNodeStyleResNumFolderShortcutShow,
	xrtNodeStyleResNumFontListSelected,
	xrtNodeStyleResNumForegroundSelected,
	xrtNodeStyleResNumIconClosed,
	xrtNodeStyleResNumIconClosedSelected,
	xrtNodeStyleResNumIconItem,
	xrtNodeStyleResNumIconItemSelected,
	xrtNodeStyleResNumIconOpen,
	xrtNodeStyleResNumIconOpenSelected,
	xrtNodeStyleResNumLayoutSpacing,
	xrtNodeStyleResNumLineColor,
	xrtNodeStyleResNumLineStyle,
	xrtNodeStyleResNumLineWidth,
	xrtNodeStyleResNumShortcutShow,
	xrtNodeStyleResNumShortcutSize,

	xrtNodeStyleResNumShortcutColor,
	size_xrtNodeStyleResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtNodeStyleResNum*/
} XrtNodeStyleResNum;

typedef enum {
	xrtColumnResNumFontList,
	xrtColumnResNumForeground,
	xrtColumnResNumHeight,
	xrtColumnResNumWidth,
	xrtColumnResNumFontListSelected,
	xrtColumnResNumLabel,
	xrtColumnResNumLabelAlignment,
	xrtColumnResNumMarginLeft,
	xrtColumnResNumMarginRight,
	xrtColumnResNumNodeAlignment,
	xrtColumnResNumResizeCallback,
	xrtColumnResNumSelected,
	xrtColumnResNumWidthResizePolicy,
	xrtColumnResNumWidthSizingPolicy,
	xrtColumnResNumWidthMaximum,
	xrtColumnResNumWidthMinimum,
	xrtColumnResNumWidthPreferredCount,

	xrtColumnResNumBackground,
	xrtColumnResNumEditable,
	size_xrtColumnResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtColumnResNum*/
} XrtColumnResNum;

typedef enum {
	xrtGearComboResNumBlinkRate,
	xrtGearComboResNumColumns,
	xrtGearComboResNumCursorPosition,
	xrtGearComboResNumCursorPositionVisible,
	xrtGearComboResNumEditable,
	xrtGearComboResNumFontList,
	xrtGearComboResNumMaxLength,
	xrtGearComboResNumMarginHeight,
	xrtGearComboResNumMarginWidth,
	xrtGearComboResNumPendingDelete,
	xrtGearComboResNumResizeWidth,
	/*	xrtGearComboResNumSelectionArray,*/
	/* xrtGearComboResNumSelectionArrayCount,*/
	xrtGearComboResNumSelectThreshold,
	xrtGearComboResNumValue,
	/*	xrtGearComboResNumValueWcs,*/
	xrtGearComboResNumVerifyBell,
	xrtGearComboResNumAlignment,
	xrtGearComboResNumArrow,
	xrtGearComboResNumArrowClass,
	xrtGearComboResNumArrowType,
	xrtGearComboResNumMenuCallback,
	xrtGearComboResNumMenuList,
	xrtGearComboResNumPickList,
	xrtGearComboResNumPickListIndex,
	xrtGearComboResNumSearchPolicy,
	xrtGearComboResNumSpacing,
	xrtGearComboResNumTextField,
	xrtGearComboResNumVisibleItemCount,
	xrtGearComboResNumAutoComplete,
	size_xrtGearComboResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtGearComboResNum*/
} XrtGearComboResNum;

typedef enum {
	xrtProgressResNumFontList,
	xrtProgressResNumMarginHeight,
	xrtProgressResNumMarginWidth,
	xrtProgressResNumMaximum,
	xrtProgressResNumMinimum,
	xrtProgressResNumRecomputeSize,
	xrtProgressResNumValue,
	xrtProgressResNumBarColor,
	xrtProgressResNumBarCount,
	xrtProgressResNumBarSpacing,
	xrtProgressResNumDoubleBuffer,
	xrtProgressResNumIcon,
	xrtProgressResNumLabelAlignment,
	xrtProgressResNumLabelFormat,
	xrtProgressResNumLabelFormatCallback,
	xrtProgressResNumLabelShow,
	xrtProgressResNumProgressCallback,
	xrtProgressResNumProgressTimeOut,
	xrtProgressResNumProgressType,
	size_xrtProgressResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtProgressResNum*/
} XrtProgressResNum;

typedef enum {
	xrtPanedWindowResNumAllowResize,
	xrtPanedWindowResNumMarginHeight,
	xrtPanedWindowResNumMarginWidth,
	xrtPanedWindowResNumMaximum,
	xrtPanedWindowResNumMinimum,
	xrtPanedWindowResNumOrientation,
	xrtPanedWindowResNumPaneResizeCallback,
	xrtPanedWindowResNumPosition,
	xrtPanedWindowResNumRecomputeSize,
	xrtPanedWindowResNumSashHeight,
	xrtPanedWindowResNumSashIndent,
	xrtPanedWindowResNumSashShadowThickness,
	xrtPanedWindowResNumSashWidth,
	xrtPanedWindowResNumSeparatorShow,
	xrtPanedWindowResNumSkipAdjust,
	xrtPanedWindowResNumSpacing,
	size_xrtPanedWindowResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtPanedWindowResNum*/
} XrtPanedWindowResNum;

#endif /*XRTGEAR_RESNUM_H*/
