/* ALL RIGHTS RESERVED
 *
 * This file is provided for demonstration and educational uses only.
 * Permission to use, copy, modify and distribute this file for
 * any purpose and without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all
 * copies, and that the name of KL Group not be used in advertising
 * or publicity pertaining to this material without the specific,
 * prior written permission of an authorized representative of
 * KL Group.
 *
 * KL GROUP MAKES NO REPRESENTATIONS AND EXTENDS NO WARRANTIES, EX-
 * PRESS OR IMPLIED, WITH RESPECT TO THE SOFTWARE, INCLUDING, BUT
 * NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
 * FITNESS FOR ANY PARTICULAR PURPOSE, AND THE WARRANTY AGAINST IN-
 * FRINGEMENT OF PATENTS OR OTHER INTELLECTUAL PROPERTY RIGHTS.  THE
 * SOFTWARE IS PROVIDED "AS IS", AND IN NO EVENT SHALL KL GROUP OR
 * ANY OF ITS AFFILIATES BE LIABLE FOR ANY DAMAGES, INCLUDING ANY
 * LOST PROFITS OR OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES
 * RELATING TO THE USE OF THIS SOFTWARE.
 *
 *
 * XRT/table widget UIM/X integration file
 *
 * $AstecId: XrtTbl_resnum.h,v 1.3 1999/10/13 11:51:39 nakayama Exp $
 *
 *  SCCSID -- @(#)XrtTbl.resnum.h	1.7    98/11/05 KL Group Inc.
 */

/******************************************************************************
				xrtTbl.resnum.h
******************************************************************************/

#ifndef XRTTBL_RESNUM_H  /*2.2.0*/
#define XRTTBL_RESNUM_H

typedef enum {
	xrtTblResNumAlignmentContext = 0,				
	xrtTblResNumAlignmentSeries,					
	xrtTblResNumAllowCellResize,					
	xrtTblResNumAllowResize,						
	xrtTblResNumBackgroundContext,				
	xrtTblResNumBackgroundPixelContext,				
	xrtTblResNumBackgroundSeries,				
	xrtTblResNumBackingStore,						
	xrtTblResNumBorderSidesContext,				
	xrtTblResNumBorderSidesSeries,				
	xrtTblResNumBorderTypeContext,				
	xrtTblResNumBorderTypeSeries,				
	xrtTblResNumBottomOffset,					
	xrtTblResNumBottomShadowContext,				
	xrtTblResNumCaseContext,
	xrtTblResNumCaseSeries,						
	xrtTblResNumCellValueCallback,					
	xrtTblResNumCellValueContext,
	xrtTblResNumCellValueFunc,					
	xrtTblResNumCellValues,						
	xrtTblResNumCharHeightContext,				
	xrtTblResNumCharHeightSeries,				
	xrtTblResNumCharWidthContext,				
	xrtTblResNumCharWidthSeries,					
	xrtTblResNumClipChildrenPersistent,				
	xrtTblResNumClipPixmapContext,					
	xrtTblResNumClipPixmapSeries,					
	xrtTblResNumColumnLabelPlacement,
	xrtTblResNumColumnLabels,					
	xrtTblResNumColumnLabelOffset,					
	xrtTblResNumContext,							
	xrtTblResNumContextValueCallback,				
	xrtTblResNumCreateWidgetCallback,			
	xrtTblResNumCursorCorner,
	xrtTblResNumCursorHorizontal,				
	xrtTblResNumCursorNontraversable,			
	xrtTblResNumCursorTraversable,				
	xrtTblResNumCursorVertical,					
	xrtTblResNumDataTypeContext,					
	xrtTblResNumDataTypeSeries,					
	xrtTblResNumDebug,							
	xrtTblResNumDisplayClipArrows,				
	xrtTblResNumDisplayHorizScrollBar,			
	xrtTblResNumDisplayVertScrollBar,		
	xrtTblResNumDisplayWidgetCallback,			
	xrtTblResNumDoubleBuffer,						
	xrtTblResNumEditableContext,					
	xrtTblResNumEditableSeries,
	xrtTblResNumEnterCellCallback,
	xrtTblResNumExportDelimiter,									
	xrtTblResNumExposeCallback,					
	xrtTblResNumFontListContext,					
	xrtTblResNumFontListSeries,
	xrtTblResNumForegroundContext,				
	xrtTblResNumForegroundSeries,				
	xrtTblResNumForegroundPixelContext,				
	xrtTblResNumFrameBorderType,					
	xrtTblResNumFrameShadowThickness,				
	xrtTblResNumFrozenColumnPlacement,
	xrtTblResNumFrozenColumns,					
	xrtTblResNumFrozenRowPlacement,				
	xrtTblResNumFrozenRows,						
	xrtTblResNumHorizScrollBarLeftAttachment,	
	xrtTblResNumHorizScrollBarPlacement,			
	xrtTblResNumHorizScrollBarPosition,			
	xrtTblResNumHorizScrollBarRightAttachment,	
	xrtTblResNumHorizontalScrollBar,			
	xrtTblResNumImportDelimiter,									
	xrtTblResNumJumpScroll,						
	xrtTblResNumLabelContext,
	xrtTblResNumLabelCreateCallback,					
	xrtTblResNumLabelCreateFunc,
	xrtTblResNumLeftColumn,						
	xrtTblResNumLeftOffset,						
	xrtTblResNumLocation,						
	xrtTblResNumMarginHeight,					
	xrtTblResNumMarginWidth,						
	xrtTblResNumMaxLengthContext,				
	xrtTblResNumMaxLengthSeries,					
	xrtTblResNumMinCellVisibility,				
	xrtTblResNumMinFlexibleHeight,					/*2.2.0*/
	xrtTblResNumMinFlexibleWidth,					/*2.2.0*/
	xrtTblResNumMode,								/*2.2.0*/
	xrtTblResNumMultilineContext,				
	xrtTblResNumMultilineSeries,					
	xrtTblResNumNumColumns,						
	xrtTblResNumNumRows,							
	xrtTblResNumOverflowContext,					
	xrtTblResNumOverflowSeries,					
	xrtTblResNumPixelHeightContext,				
	xrtTblResNumPixelHeightSeries,				
	xrtTblResNumPixelWidthContext,				
	xrtTblResNumPixelWidthSeries,				
	xrtTblResNumPixmapContext,					
	xrtTblResNumPixmapLayoutContext,				
	xrtTblResNumPixmapLayoutSeries,				
	xrtTblResNumPixmapSeries,			
	xrtTblResNumPixmapShadowContext,				
	xrtTblResNumPixmapShadowSeries,					
	xrtTblResNumPrintCallback,							
	xrtTblResNumPrintWidgetCallback,				
	xrtTblResNumPSFontListContext,				
	xrtTblResNumPSFontListSeries,				
	xrtTblResNumPSFontMapList,						
	xrtTblResNumRangeContext,					
	xrtTblResNumRepaint,							
	xrtTblResNumRepeatBackgroundColors,				
	xrtTblResNumRepeatForegroundColors,				
	xrtTblResNumResizeCallback,					
	xrtTblResNumResizeCellCallback,				
	xrtTblResNumRightOffset,						
	xrtTblResNumRowLabelOffset,						
	xrtTblResNumRowLabelPlacement,				
	xrtTblResNumRowLabels,						
	xrtTblResNumScrollCallback,						
	xrtTblResNumSelectCallback,					
	xrtTblResNumSelectedBackground,
	xrtTblResNumSelectedCellList,
	xrtTblResNumSelectedForeground,				
	xrtTblResNumSelectionPolicy,					
	xrtTblResNumSetTextCursorPos,					
	xrtTblResNumShadowThickness,					
	xrtTblResNumSortCallback,						
	xrtTblResNumSpace,							
	xrtTblResNumSpanList,						
	xrtTblResNumText,							
	xrtTblResNumTextInitSelect,							
	xrtTblResNumTopOffset,						
	xrtTblResNumTopRow,							
	xrtTblResNumTopShadowContext,							
	xrtTblResNumTrackCursor,						
	xrtTblResNumTrackCursorCallback,				
	xrtTblResNumTraversableContext,				
	xrtTblResNumTraversableSeries,				
	xrtTblResNumTraverseCellCallback,			
	xrtTblResNumUseXmGetColors,						
	xrtTblResNumValidateCellCallback,			
	xrtTblResNumValidatePolicy,					
	xrtTblResNumVertScrollBarBottomAttachment,	
	xrtTblResNumVertScrollBarPlacement,			
	xrtTblResNumVertScrollBarPosition,			
	xrtTblResNumVertScrollBarTopAttachment,		
	xrtTblResNumVerticalScrollBar,				
	xrtTblResNumVisibleColumns,					
	xrtTblResNumVisibleRows,						
	xrtTblResNumWidgetLocation,					
	xrtTblResNumWidgetClassList,
	xrtTblResNumWidgetContext,					
	xrtTblResNumWidgetSeries,					
	xrtTblResNumWidgetSetValueCallback,				
	xrtTblResNumWidgetShadowContext,				
	xrtTblResNumWidgetShadowSeries,					
	xrtTblResNumWordWrapContext,								
	xrtTblResNumWordWrapSeries,						
	xrtTblResNumXmStringGetMode,					
	xrtTblResNumXmStringSetMode,					
	xrtTblResNumExportCallback,
	xrtTblResNumImportCallback,

	xrtTblResNumCurrencyPickListContext,
	xrtTblResNumCurrencyPickListSeries,
	xrtTblResNumDatePickListContext,
	xrtTblResNumDatePickListSeries,
	xrtTblResNumFloatPickListContext,
	xrtTblResNumFloatPickListSeries,
	xrtTblResNumIntPickListContext,
	xrtTblResNumIntPickListSeries,
	xrtTblResNumPreviewScrolling,
	xrtTblResNumResizeToCell,
	xrtTblResNumSensitiveContext,
	xrtTblResNumSensitiveSeries,
	xrtTblResNumStringPickListContext,
	xrtTblResNumStringPickListSeries,
    size_xrtTblResNum					/* holds number of enums defined */
	/* don't add new enums after size_xrtTblResNum*/
} XrtTblResNum;

typedef enum {
	xrtLblResNumAlignment,			
	xrtLblResNumFontList,			
	xrtLblResNumLabelPixmap,			
	xrtLblResNumLabelString,			
	xrtLblResNumLabelType,			
	xrtLblResNumMarginHeight,		
	xrtLblResNumMarginWidth,			
	xrtLblResNumRecomputeSize,
	xrtLblResNumShadowThickness,
	xrtLblResNumStringDirection,
	xrtLblResNumBackgroundString,
	xrtLblResNumBorderType,
	xrtLblResNumForegroundString,
	xrtLblResNumRotation,
    size_xrtLblResNum				/* holds number of enums defined */
	/* don't add new enums after size_xrtLblResNum*/
} XrtLblResNum;

#endif /*XRTTBL_RESNUM_H*/
