/*------------------------------------------------------------------------------
 * $Source: /rcs/rcs2/include/uxgui.h,v $
 * $Date: 1997/08/12 14:53:38 $		$Revision: 2.46.65.7 $
 *------------------------------------------------------------------------------
 *		Copyright (c) 1992, Visual Edge Software Ltd.
 *
 * ALL  RIGHTS  RESERVED.  Permission  to  use,  copy,  modify,  and
 * distribute  this  software  and its documentation for any purpose
 * and  without  fee  is  hereby  granted,  provided  that the above
 * copyright  notice  appear  in  all  copies  and  that  both  that
 * copyright  notice and this permission notice appear in supporting
 * documentation,  and that  the name of Visual Edge Software not be
 * used  in advertising  or publicity  pertaining to distribution of
 * the software without specific, written prior permission. The year
 * included in the notice is the year of the creation of the work.
 *------------------------------------------------------------------------------
 * Variables set by the user to decide whether a UIM/X GUI is needed or not.
 *----------------------------------------------------------------------------*/

#ifndef UXGUI_H_DEFINED
#define UXGUI_H_DEFINED

#include <stdio.h>
#include <Xm/Xm.h>
#include "uxproto.h"
#include "vhandle.h"
#include "resource.h"
#include "pedit-aux.h"
#include "ifBrows.cl.h"

/* Settings available to user */

#define NO	0
#define YES	1

/* User Settings */

#ifdef DTSCRIPT

#define I_WANT_CPWRT_BOX		YES
#define I_WANT_FILE_BOX			YES
#define I_WANT_MSG_BOX			YES
#define I_WANT_DIR_SEL			YES
#define I_WANT_WRITE_C_CODE		YES
#define I_WANT_PROPERTY_EDITOR		YES
#define I_WANT_COLOR_VIEWER		YES
#define I_WANT_FONT_VIEWER		YES
#define I_WANT_PIXMAP_VIEWER		YES
#define	I_WANT_TEXT_EDITOR		YES
#define I_WANT_CB_EDITOR		NO
#define I_WANT_CONSTRAINT_EDITOR	NO
#define I_WANT_MAINWIN_EDITOR		NO
#define I_WANT_MENU_EDITOR		NO
#define I_WANT_CONNECTION_EDITOR	NO
#define I_WANT_METHOD_EDITOR		NO
#define I_WANT_DECL_EDITOR		NO
#define I_WANT_BROWSER			NO
#define I_WANT_BRIFLST			NO
#define I_WANT_TTAB_EDITOR		NO
#define	I_WANT_TTAB_LIST		NO
#define I_WANT_ACTION_EDITOR		NO
#define I_WANT_EVENT_EDITOR		NO
#define I_WANT_PL_EDITOR		NO
#define I_WANT_INTERP			NO
#define I_WANT_CGEN_OPTIONS		NO
#define I_WANT_CUR_DIR			NO
#define I_WANT_ARRANGE_OPTIONS		NO
#define I_WANT_GRID_OPTIONS		NO
#define I_WANT_BHELP_OPTIONS		NO
#define I_WANT_BROWSER_OPTIONS		NO
#define I_WANT_TEXT_EDTOPT		NO
#define I_WANT_HELP			YES

#else
#ifdef DTBUILDER

#define I_WANT_CPWRT_BOX		YES
#define I_WANT_FILE_BOX			YES
#define I_WANT_MSG_BOX			YES
#define I_WANT_DIR_SEL			YES
#define I_WANT_WRITE_C_CODE		YES
#define I_WANT_PROPERTY_EDITOR		YES
#define I_WANT_COLOR_VIEWER		YES
#define I_WANT_FONT_VIEWER		YES
#define I_WANT_PIXMAP_VIEWER		YES
#define I_WANT_TEXT_EDITOR		YES
#define I_WANT_CB_EDITOR		YES
#define I_WANT_CONSTRAINT_EDITOR	YES
#define I_WANT_MAINWIN_EDITOR		YES
#define I_WANT_MENU_EDITOR		YES
#define I_WANT_CONNECTION_EDITOR	YES
#define I_WANT_METHOD_EDITOR		NO
#define I_WANT_DECL_EDITOR		YES
#define I_WANT_BROWSER			YES
#define I_WANT_BRIFLST			NO
#define I_WANT_TTAB_EDITOR		NO
#define I_WANT_TTAB_LIST		NO
#define I_WANT_ACTION_EDITOR		NO
#define I_WANT_EVENT_EDITOR		NO
#define I_WANT_PL_EDITOR		YES
#define I_WANT_INTERP			NO
#define I_WANT_CGEN_OPTIONS		YES
#define I_WANT_CUR_DIR			NO
#define I_WANT_ARRANGE_OPTIONS		NO
#define I_WANT_GRID_OPTIONS		NO
#define I_WANT_BHELP_OPTIONS		NO
#define I_WANT_BROWSER_OPTIONS		NO
#define I_WANT_TEXT_EDTOPT		NO
#define I_WANT_HELP			YES

#else
#ifdef PLAT

#define I_WANT_CPWRT_BOX		YES
#define I_WANT_FILE_BOX			YES
#define I_WANT_MSG_BOX			YES
#define I_WANT_DIR_SEL			YES
#define I_WANT_WRITE_C_CODE		YES
#define I_WANT_PROPERTY_EDITOR		YES
#define I_WANT_COLOR_VIEWER		YES
#define I_WANT_XK_COLOR_VIEWER		YES
#define I_WANT_FONT_VIEWER		YES
#define I_WANT_XK_FONT_VIEWER		YES
#define I_WANT_XK_TIPFONT_VIEWER	YES
#define I_WANT_PIXMAP_VIEWER		YES
#define I_WANT_XK_PIXMAP_VIEWER		YES
#define I_WANT_TEXT_EDITOR		YES
#define I_WANT_CB_EDITOR		YES
#define I_WANT_CONSTRAINT_EDITOR	YES
#define I_WANT_MAINWIN_EDITOR		YES
#define I_WANT_MENU_EDITOR		YES
#define I_WANT_CONNECTION_EDITOR	YES
#define I_WANT_METHOD_EDITOR		YES
#define I_WANT_DECL_EDITOR		YES
#define I_WANT_BROWSER			YES
#define I_WANT_BRIFLST			YES
#define I_WANT_TTAB_EDITOR		YES
#define I_WANT_TTAB_LIST		YES
#define I_WANT_ACTION_EDITOR		YES
#define I_WANT_EVENT_EDITOR		YES
#define I_WANT_PL_EDITOR		YES
#define I_WANT_INTERP			YES
#define I_WANT_CGEN_OPTIONS		YES
#define I_WANT_CUR_DIR			YES
#define I_WANT_ARRANGE_OPTIONS		YES
#define I_WANT_GRID_OPTIONS		YES
#define I_WANT_BHELP_OPTIONS		YES
#define I_WANT_BROWSER_OPTIONS		YES
#define I_WANT_TEXT_EDTOPT		YES
#define I_WANT_HELP			YES

#else /* UIMX */

#define I_WANT_CPWRT_BOX		YES
#define I_WANT_FILE_BOX			YES
#define I_WANT_MSG_BOX			YES
#define I_WANT_DIR_SEL			YES
#define I_WANT_WRITE_C_CODE		YES
#define I_WANT_PROPERTY_EDITOR		YES
#define I_WANT_COLOR_VIEWER		YES
#define I_WANT_FONT_VIEWER		YES
#define I_WANT_PIXMAP_VIEWER		YES
#define I_WANT_TEXT_EDITOR		YES
#define I_WANT_CB_EDITOR		YES
#define I_WANT_CONSTRAINT_EDITOR	YES
#define I_WANT_MAINWIN_EDITOR		YES
#define I_WANT_MENU_EDITOR		YES
#define I_WANT_CONNECTION_EDITOR	YES
#define I_WANT_METHOD_EDITOR		YES
#define I_WANT_DECL_EDITOR		YES
#define I_WANT_BROWSER			YES
#define I_WANT_BRIFLST			YES
#define I_WANT_TTAB_EDITOR		YES
#define I_WANT_TTAB_LIST		YES
#define I_WANT_ACTION_EDITOR		YES
#define I_WANT_EVENT_EDITOR		YES
#define I_WANT_PL_EDITOR		YES
#define I_WANT_INTERP			YES
#define I_WANT_CGEN_OPTIONS		YES
#define I_WANT_CUR_DIR			YES
#define I_WANT_ARRANGE_OPTIONS		YES
#define I_WANT_GRID_OPTIONS		YES
#define I_WANT_BHELP_OPTIONS		YES
#define I_WANT_BROWSER_OPTIONS		YES
#define I_WANT_TEXT_EDTOPT		YES
#define I_WANT_HELP			YES

#endif /* PLAT */
#endif /* DTBUILDER */
#endif /* DTSCRIPT */

/* COSE settings */

#ifdef COSE
#define I_WANT_CDE_EXTENSIONS		YES
#else
#define I_WANT_CDE_EXTENSIONS		NO
#endif /* COSE */

/* Indigo Magic Desktop setting */

#ifdef sgi
#define I_WANT_IMD_EXTENSIONS		YES
#else
#define I_WANT_IMD_EXTENSIONS		NO
#endif /* sgi */

/* Help Items used by UxGUIPopupHelpBox() */

#define HELP_ON_OVERVIEW	1   /* Beginning */
#define HELP_ON_REFERENCE	2   /* General */
#define HELP_ON_TASKS		3
#define HELP_ON_REFERENCE_PRW	4   /* PRoject Window */
#define HELP_ON_TASKS_PRW	5
#define HELP_ON_REFERENCE_BRW	6   /* BRoWser */
#define HELP_ON_TASKS_BRW	7 
#define HELP_ON_REFERENCE_PAL	8   /* PALette */
#define HELP_ON_TASKS_PAL	9
#define HELP_ON_REFERENCE_PED	10  /* Property EDitor */
#define HELP_ON_TASKS_PED	11
#define HELP_ON_REFERENCE_CVW	12  /* Color VieWer */
#define HELP_ON_TASKS_CVW       13
#define HELP_ON_REFERENCE_CED	14  /* Color EDitor */
#define HELP_ON_TASKS_CED       15
#define HELP_ON_REFERENCE_CMP	16  /* Color MaP */
#define HELP_ON_TASKS_CMP       17
#define HELP_ON_REFERENCE_FVW	18  /* Font VieWer */
#define HELP_ON_TASKS_FVW       19
#define HELP_ON_REFERENCE_PVW	20  /* Pixmap VieWer */
#define HELP_ON_TASKS_PVW	21
#define HELP_ON_REFERENCE_CNE	22  /* CoNnection Editor */
#define HELP_ON_TASKS_CNE	23
#define HELP_ON_REFERENCE_CSE	24  /* ConStraint Editor */
#define HELP_ON_TASKS_CSE	25
#define HELP_ON_REFERENCE_MED	26  /* Menu EDitor */
#define HELP_ON_TASKS_MED	27
#define HELP_ON_REFERENCE_DCE	28  /* DeClaration Editor */
#define HELP_ON_TASKS_DCE	29
#define HELP_ON_REFERENCE_PLE	30  /* Program Layout Editor */
#define HELP_ON_TASKS_PLE	31
#define HELP_ON_REFERENCE_MWE	32  /* Main Window Editor */
#define HELP_ON_TASKS_MWE	33
#define HELP_ON_REFERENCE_MTE	34  /* MeThod Editor */
#define HELP_ON_TASKS_MTE	35
#define HELP_ON_REFERENCE_TTE	36  /* Translation Table Editor */
#define HELP_ON_TASKS_TTE	37
#define HELP_ON_REFERENCE_TTL	38  /* Translation Table List */
#define HELP_ON_TASKS_TTL	39
#define HELP_ON_REFERENCE_EVE	40  /* EVent Editor */
#define HELP_ON_TASKS_EVE	41
#define HELP_ON_REFERENCE_ATE	42  /* Action Table Editor */
#define HELP_ON_TASKS_ATE	43
#define HELP_ON_REFERENCE_INT	44  /* INTerpreter */
#define HELP_ON_TASKS_INT	45
#define HELP_ON_REFERENCE_CBE	46  /* CallBack Editor */
#define HELP_ON_TASKS_CBE	47
#define HELP_ON_REFERENCE_TXE	48  /* TeXt Editor */
#define HELP_ON_TASKS_TXE	49
#define HELP_ON_USING_HELP	50
#define HELP_ON_ABOUT_PROD	51

/* External functions declarations */

extern void	UxPopupBrowserIfList UXPROTO(( Widget, XtPointer, XtPointer ));
extern swidget	UxCreateInterp UXPROTO(( void ));
extern swidget	UxGetInterpInterface UXPROTO(( void ));
extern swidget	UxPopupBrowserOptions UXPROTO(( swidget *));
extern swidget	UxPopupColorView UXPROTO(( swidget, char*, char*, swidget*, int, Widget, char* (*)(), void (*)(), void (*)()));
extern int	UxPopupDirSelBox UXPROTO(( char*, char**));
extern swidget	UxPopupCurrentDirectory UXPROTO((char*, char* (*)(), swidget*, char* (*)() ));
extern swidget	UxPopupMethodEditor UXPROTO(( swidget, char*)); 
extern swidget	UxPopupTextGeometryOptions UXPROTO(( swidget*)); 
extern int	UxPopupWriteCCode UXPROTO(( swidget));
extern swidget	UxPopupCallbackEditor UXPROTO(( swidget, char*, char*, swidget*, int));
extern int	UxResetCBTed UXPROTO(( swidget ));
extern swidget	UxPopupFontView UXPROTO(( swidget, char*, char*, Widget, char* (*)(), void (*)(), void (*)()));
extern swidget	UxPopupPixView UXPROTO(( swidget, char*, char*, Widget, char* (*)(), void (*)(), void (*)())); 
extern void	UxDestroyTextTool UXPROTO(( swidget));
extern swidget	UxCreateTextTool UXPROTO((swidget, char*, char*, void (*)(), char*, void (*)(), char*, void (*)(), char*, void (*)(), char*)); 
extern void 	UxPopupTextTool UXPROTO(( swidget, char*));
extern void 	UxUpdateTextToolLabelLeft UXPROTO(( vhandle, char*));
extern swidget	UxPopupPLed UXPROTO(( void ));
extern void	UxAboutUimx UXPROTO(( void ));
extern void 	UxGettingStarted UXPROTO(( void ));
extern void	UxPopupDTHelpBox UXPROTO(( int ));
extern void	UxPopupIMDHelpBox UXPROTO(( int ));
extern void	UxPopupNormalHelpBox UXPROTO(( int ));
extern swidget	UxPopupActionEditor UXPROTO(( vhandle)); 
extern swidget	UxPopupEventEditor UXPROTO(( char*, char*, vhandle ));
extern swidget	UxPopupDeclEditor UXPROTO(( swidget));
extern int	UxUpdateDeclEditor UXPROTO(( vhandle ,vhandle, int ));
extern swidget	UxPopupArrange UXPROTO(( swidget* ));
extern swidget	UxPopupGrid UXPROTO(( swidget* ));
extern swidget	UxPopupBubbleHelp UXPROTO(( swidget* ));
extern int	UxTransTableEditorObsUpdate UXPROTO(( vhandle ,vhandle, int ));
extern swidget	UxPopupTranslationTableEditor UXPROTO(( vhandle ,vhandle ));
extern void	UxTransTableApplyFromEventEditor UXPROTO(( char*, char*)); 
extern int	UxTransTableListObsUpdate UXPROTO(( vhandle ,vhandle, int ));
extern swidget	UxPopupTransTableList UXPROTO(( vhandle ,vhandle,int ));
extern void	UxSetSelectStateOfTransTableIcon UXPROTO(( swidget));
extern int	UxMeObsUpdateMenu UXPROTO(( vhandle ,vhandle, int ));
extern int	UxMeObsUpdateButt UXPROTO(( vhandle ,vhandle, int ));
extern int	UxMeObsUpdateSep UXPROTO(( vhandle ,vhandle, int ));
extern int	UxMeObsUpdateMenuEd UXPROTO(( vhandle ,vhandle, int ));
extern int	UxMeObsUpdatePane UXPROTO(( vhandle ,vhandle, int ));
extern swidget	UxNoviceMePopup UXPROTO(( swidget ));
extern swidget	UxMePopup UXPROTO(( swidget, swidget, int, int));
extern int	UxMeEditedMenu UXPROTO(( vhandle ,vhandle, int ));
extern Boolean	UxMeBlocksAddUpdate UXPROTO(( void ));
extern swidget	UxMwePopup UXPROTO(( swidget ));
extern int	UxMweObsUpdate UXPROTO(( vhandle ,vhandle, int ));
extern swidget	UxPopupConsEditor UXPROTO(( swidget ));
extern int	UxDialog UXPROTO(( char*, char*, char** ));
extern int	UxDialogValidated UXPROTO(( char*, char*, char**, char* (*)() ));

#ifdef _IBMR2
extern int	UxCodeDialog UXPROTO(( char*, char*, char** , int ));
#endif /* _IBMR2 */

extern void	UxPeRelease UXPROTO(( swidget, swidget));
extern Boolean	UxPeReserve UXPROTO(( swidget, char*, swidget, char**, PeSlot_t** )); 
extern void	UxPeDepositValue UXPROTO(( swidget, PeSlot_t* ,char* ));
extern void	UxPeDepositSource UXPROTO(( swidget, PeSlot_t*,char* ));
extern swidget	UxPopupPropertyEditor UXPROTO(( object* ));
extern swidget	UxStartupPropertyEditor UXPROTO(( object* ));
extern int	UxPtObsUpdate UXPROTO(( vhandle ,vhandle, int )); 
extern void	UxCopyright UXPROTO(( void ));
extern int	UxWarning UXPROTO(( char* ));
extern int	UxStatus UXPROTO(( char* ));
extern int	UxError UXPROTO(( char* ));
extern int	UxFatalError UXPROTO(( char* ));
extern int	UxWarningGeneric UXPROTO(( char*, char*, char*, char* )); 
extern void	UxLoadBrowserCB UXPROTO(( Widget, XtPointer, XmToggleButtonCallbackStruct* ));
extern int	UxObsBrowser UXPROTO(( vhandle ,vhandle, int ));
extern void	UxSetBrowserReorderFlag UXPROTO(( Boolean ));
extern void	UxUpdateBrowserStartup UXPROTO(( swidget));
extern ifBrowser *UxGetIfBrowser UXPROTO(( swidget));
extern swidget	UxPopupIfBrowser UXPROTO(( vhandle ));
extern swidget	UxCreateIfBrowser UXPROTO(( vhandle ));
extern swidget	UxSelectedSwidgetsInThisBrowser UXPROTO(( ifBrowser* )); 
extern void	UxBrowserTextAppend UXPROTO(( char* ));
extern void	UxDealWithBrowserAsStartup UXPROTO(( swidget));
extern void	UxAddBrowserComponent UXPROTO(( ifBrowser*, swidget, swidget ));
extern void	UxRepopulateBrowser UXPROTO(( ifBrowser* ));
extern void	UxSelListObs UXPROTO(( swidget));
extern swidget	UxPopupCgenOptions UXPROTO(( swidget* ));
extern swidget	UxPopupConnectionEditor UXPROTO((swidget, swidget));
extern void	UxConnEditDeleteSwidgetConnections UXPROTO((swidget));
extern void	UxCDEDropRegister UXPROTO(( Widget ));
extern void	UxCDEDropUnRegister UXPROTO(( Widget ));
extern void	UxCDEWorkspaceSet UXPROTO(( Widget ));
extern void	UxCDESessionInitialize UXPROTO(( Widget ));
extern swidget	Uxcreate_view_Motif_pixmap UXPROTO((swidget, swidget));


#ifdef PLAT
extern swidget	XkPopupColorView UXPROTO(( swidget, char*, char*,swidget*,int));
extern swidget	XkPopupFontView UXPROTO(( swidget, char*, char*));
extern swidget	XkPopupTipFontView UXPROTO(( swidget, char*, char*));
extern swidget	Uxcreate_view_pixmap UXPROTO((swidget, swidget));
#endif /* PLAT */

/* GUI Wrapper function declarations. */

void	UxGUIPopupBrowserIfList UXPROTO(( Widget, XtPointer, XtPointer ));
swidget	UxGUICreateInterp UXPROTO(( void ));
swidget	UxGUIGetInterpInterface UXPROTO(( void ));
swidget UxGUIPopupBrowserOptions UXPROTO(( swidget *));
swidget UxGUIPopupColorView UXPROTO(( swidget, char*, char*, swidget*, int));
swidget UxGUIPopupBEColorView UXPROTO(( swidget, char*, char*, swidget*, int, Widget, char* (*)(), void (*)(), void (*)()));
int	UxGUIPopupDirSelBox UXPROTO(( char*, char**));
swidget UxGUIPopupCurrentDirectory UXPROTO((char*, char* (*)(), swidget*, char* (*)() ));
swidget UxGUIPopupMethodEditor UXPROTO(( swidget, char*)); 
swidget UxGUIPopupTextGeometryOptions UXPROTO(( swidget*)); 
int 	UxGUIPopupWriteCCode UXPROTO(( swidget));
swidget UxGUIPopupCallbackEditor UXPROTO(( swidget, char*, char*, swidget*, int));
void	UxGUIUpdateCallbackEditorWidgets UXPROTO((swidget, swidget*,int));
int	UxGUIResetCBTed UXPROTO(( swidget ));
swidget UxGUIPopupFontView UXPROTO(( swidget, char*, char*));
swidget UxGUIPopupBEFontView UXPROTO(( swidget, char*, char*, Widget, char* (*)(), void (*)(), void (*)()));
swidget UxGUIPopupPixView UXPROTO(( swidget, char*, char*)); 
swidget UxGUIPopupBEPixView UXPROTO(( swidget, char*, char*, Widget, char* (*)(), void (*)(), void (*)())); 
void 	UxGUIDestroyTextTool UXPROTO(( swidget));
swidget UxGUICreateTextTool UXPROTO((swidget, char*, char*, void (*)(), char*, void (*)(), char*, void (*)(), char*, void (*)(), char*, char*, void*)); 
void 	UxGUIPopupTextTool UXPROTO(( swidget, char*));
void 	UxGUIUpdateTextToolLabelLeft UXPROTO(( vhandle, char*));
swidget UxGUIPopupPLed UXPROTO(( void ));
void 	UxGUIAboutUimx UXPROTO(( void ));
void 	UxGUIGettingStarted UXPROTO(( void ));
char*	UxGUIHelpVolumeName UXPROTO(( void ));
char*	UxGUICoseVolumeName UXPROTO(( void ));
void	UxGUIPopupHelpBox UXPROTO(( int ));
swidget UxGUIPopupActionEditor UXPROTO(( vhandle)); 
swidget UxGUIPopupEventEditor UXPROTO(( char*, char*, vhandle ));
swidget UxGUIPopupDeclEditor UXPROTO(( swidget));
int	UxGUIUpdateDeclEditor UXPROTO(( vhandle ,vhandle, int ));
swidget	UxGUIPopupArrange UXPROTO(( swidget* ));
swidget UxGUIPopupGrid UXPROTO(( swidget* ));
swidget UxGUIPopupBubleHelp UXPROTO(( swidget* ));
int	UxGUITransTableEditorObsUpdate UXPROTO(( vhandle ,vhandle, int ));
swidget	UxGUIPopupTranslationTableEditor UXPROTO(( vhandle ,vhandle ));
void	UxGUITransTableApplyFromEventEditor UXPROTO(( char*, char*));
int	UxGUITransTableListObsUpdate UXPROTO(( vhandle ,vhandle,int ));
swidget	UxGUIPopupTransTableList UXPROTO(( vhandle ,vhandle,int ));
void	UxGUISetSelectStateOfTransTableIcon UXPROTO(( swidget));
int	UxGUIMeObsUpdateMenu UXPROTO(( vhandle ,vhandle,int ));
int	UxGUIMeObsUpdateButt UXPROTO(( vhandle ,vhandle,int ));
int	UxGUIMeObsUpdateSep UXPROTO(( vhandle ,vhandle, int ));
int	UxGUIMeObsUpdateMenuEd UXPROTO(( vhandle ,vhandle, int ));
int	UxGUIMeObsUpdatePane UXPROTO(( vhandle ,vhandle, int ));
swidget	UxGUIMePopup UXPROTO(( swidget, swidget, int, int));
int	UxGUIMeEditedMenu UXPROTO(( vhandle ,vhandle, int ));
Boolean	UxGUIMeBlocksAddUpdate UXPROTO(( void ));
swidget	UxGUIMwePopup UXPROTO(( swidget ));
int	UxGUIMweObsUpdate UXPROTO(( vhandle ,vhandle, int ));
swidget	UxGUIPopupConsEditor UXPROTO(( swidget ));
int	UxGUIDialog UXPROTO(( char*, char*, char** ));
int	UxGUIDialogValidated UXPROTO(( char*, char*, char**, char* (*)() ));

#ifdef _IBMR2
int	UxGUICodeDialog UXPROTO(( char*, char*, char** , int ));
#endif /* _IBMR2 */

void	UxGUIPeRelease UXPROTO(( swidget, swidget));
Boolean	UxGUIPeReserve UXPROTO(( swidget, char*, swidget, char**, PeSlot_t** ));
void	UxGUIPeDepositValue UXPROTO(( swidget, PeSlot_t* ,char* ));
void	UxGUIPeDepositSource UXPROTO(( swidget, PeSlot_t*,char* ));
swidget	UxGUIPopupPropertyEditor UXPROTO(( object* ));
swidget	UxGUIStartupPropertyEditor UXPROTO(( object* ));
int	UxGUIPtObsUpdate UXPROTO(( vhandle ,vhandle, int )); 
void	UxGUICopyright UXPROTO(( void ));
int	UxGUIWarning UXPROTO(( char* ));
int	UxGUIStatus UXPROTO(( char* ));
int	UxGUIError UXPROTO(( char* ));
int	UxGUIFatalError UXPROTO(( char* ));
int	UxGUIWarningGeneric UXPROTO(( char*, char*, char*, char* )); 
void	UxGUILoadBrowserCB UXPROTO(( Widget, XtPointer, XmToggleButtonCallbackStruct* ));
int	UxGUIObsBrowser UXPROTO(( vhandle ,vhandle, int ));
void	UxGUISetBrowserReorderFlag UXPROTO(( Boolean ));
void	UxGUIUpdateBrowserStartup UXPROTO(( swidget));
ifBrowser *UxGUIGetIfBrowser UXPROTO(( swidget));
swidget	UxGUIPopupIfBrowser UXPROTO(( vhandle ));
swidget	UxGUICreateIfBrowser UXPROTO(( vhandle ));
swidget	UxGUISelectedSwidgetsInThisBrowser UXPROTO(( ifBrowser* )); 
void	UxGUIBrowserTextAppend UXPROTO(( char* ));
void	UxGUIDealWithBrowserAsStartup UXPROTO(( swidget));
void	UxGUIAddBrowserComponent UXPROTO(( ifBrowser*, swidget, swidget ));
void	UxGUIRepopulateBrowser UXPROTO(( ifBrowser* ));
void	UxGUISelListObs UXPROTO(( swidget));
swidget	UxGUIPopupCgenOptions UXPROTO(( swidget* ));
swidget UxGUIPopupConnectionEditor UXPROTO((swidget, swidget));
int	UxGUIUsingConnectionEditor UXPROTO(( void ));
void	UxGUICDEDropRegisterIfaceArea UXPROTO(( Widget ));
void	UxGUICDEDropRegisterPalArea UXPROTO(( Widget ));
void	UxGUICDEDropRegisterMsgArea UXPROTO(( Widget ));
void	UxGUICDEDropUnRegisterIfaceArea UXPROTO(( Widget ));
void	UxGUICDEDropUnRegisterPalArea UXPROTO(( Widget ));
void	UxGUICDEDropUnRegisterMsgArea UXPROTO(( Widget ));
void	UxGUICDEWorkspaceSet UXPROTO(( Widget ));
void	UxGUICDESessionIntialize UXPROTO(( Widget ));

#ifdef PLAT
swidget	XkGUIPopupColorView UXPROTO(( swidget, char*, char*, swidget*, int));
swidget	XkGUIPopupFontView UXPROTO(( swidget, char*, char*));
swidget	XkGUIPopupTipFontView UXPROTO(( swidget, char*, char*));
swidget	XkGUIPopupPixView UXPROTO(( swidget, char*, char*)); 
#endif /* PLAT */

#endif /* UXGUI_H_DEFINED */
